/*
 * Funambol is a mobile platform developed by Funambol, Inc. 
 * Copyright (C) 2009 Funambol, Inc.
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission 
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE 
 * WARRANTY OF NON INFRINGEMENT  OF THIRD PARTY RIGHTS.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Affero General Public License 
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 * 
 * You can contact Funambol, Inc. headquarters at 643 Bair Island Road, Suite 
 * 305, Redwood City, CA 94063, USA, or at email address info@funambol.com.
 * 
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 * 
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably 
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol".
 */

package com.funambol.mailclient.ui.view;

import javax.microedition.midlet.MIDlet;
import javax.microedition.lcdui.Display;
import net.rim.device.api.system.KeyListener;
import net.rim.device.api.system.Application;


public class CanvasKeyListener implements KeyListener {

    private static final int MENU_KEY = 268566528;
    private static final int BACK_KEY = 1769472;

    private MIDlet midlet;


    public CanvasKeyListener(MIDlet midlet) {
        this.midlet = midlet;
        Application app = Application.getApplication();
        app.addKeyListener(this);
    }

    public boolean keyChar(char key, int status, int time) {
        return false;
    }
    public boolean keyDown(int keycode, int time) {
        System.out.println("****** keyDown " + keycode);
        Object screen = Display.getDisplay(midlet).getCurrent();
        if (screen instanceof CustomMenuCanvas) {
            if (keycode == MENU_KEY) {
                CustomMenuCanvas canvas = (CustomMenuCanvas)screen;
                canvas.keyPressed(-6);
                return true;
            } else if (keycode == BACK_KEY) {
                // If the menu is opened we shall close it, while if it is
                // closed....
                CustomMenuCanvas canvas = (CustomMenuCanvas)screen;
                canvas.keyPressed(-7);
                return true;
            }
        }
        return false;
    }
    public boolean keyRepeat(int keycode, int time) {
        System.out.println("****** keyRepeat " + keycode);
        return true;
    }
    public boolean keyStatus(int keycode, int time) {
        return false;
    }
    public boolean keyUp(int keycode, int time) {
        return false;
    }


}

