/*
 * Funambol is a mobile platform developed by Funambol, Inc.
 * Copyright (C) 2003 - 2007 Funambol, Inc.
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE
 * WARRANTY OF NON INFRINGEMENT  OF THIRD PARTY RIGHTS.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 *
 * You can contact Funambol, Inc. headquarters at 643 Bair Island Road, Suite
 * 305, Redwood City, CA 94063, USA, or at email address info@funambol.com.
 *
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 *
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol".
 */
package com.funambol.mailclient.ui.controller;

import com.funambol.mail.BodyPart;
import com.funambol.mail.Multipart;
import com.funambol.mailclient.Funambol;
import com.funambol.mailclient.cm.AlreadyExistentContactException;
import com.funambol.mailclient.cm.ContactManagerFactory;
import com.funambol.mailclient.sm.SyncClient;
import com.funambol.mailclient.ui.utils.ImageAttachment;

import com.funambol.mailclient.ui.utils.UiUtils;
import com.funambol.mailclient.ui.view.AboutScreen;
import com.funambol.mailclient.ui.view.AccountSettingsForm;
import com.funambol.mailclient.ui.view.AddContactForm;
import com.funambol.mailclient.ui.view.AdvancedContactForm;
import com.funambol.mailclient.ui.view.ContactList;
import com.funambol.mailclient.ui.view.ViewMessageScreen;
import com.funambol.mailclient.ui.view.GeneralSettingsForm;
import com.funambol.mailclient.ui.view.LinkList;
import com.funambol.mailclient.ui.view.LogViewerForm;
import com.funambol.mailclient.ui.view.ContactPhoneNumbersList;
import com.funambol.mailclient.ui.view.Drawer;
import com.funambol.mailclient.ui.view.UpdateAlert;
import com.funambol.mailclient.ui.view.DraftMessageList;
import com.funambol.mailclient.ui.view.InboxMessageList;
import com.funambol.mailclient.ui.view.MessageList;
import com.funambol.mailclient.ui.view.OutboxMessageList;
import com.funambol.mailclient.ui.view.SentMessageList;
import com.funambol.mailclient.ui.view.RecipientList;
import com.funambol.mailclient.ui.view.FileExplorerScreen;
import com.funambol.mailclient.ui.view.FileExplorerScreenListener;
import com.funambol.mailclient.ui.view.ImageViewerScreen;
import com.funambol.mailclient.ui.view.AlertableScreen;
import com.funambol.mailclient.ui.view.AlertScreen;
import com.funambol.mailclient.ui.view.AlertDetailsScreen;

import com.funambol.mailclient.UpdaterManager;
import com.funambol.mailclient.loc.Localization;
import com.funambol.mailclient.cm.Contact;
import com.funambol.mailclient.cm.ContactManager;
import com.funambol.mailclient.cm.ContactManagerException;
import com.funambol.mailclient.mm.MessageManager;
import com.funambol.mailclient.mm.FormattedEmailStore;

import com.funambol.mailclient.config.*;
import com.funambol.mailclient.UserAccount;

import com.funambol.mail.Address;
import com.funambol.mail.Folder;
import com.funambol.mail.AccountFolder;
import com.funambol.mail.MailException;
import com.funambol.mail.Message;
import com.funambol.mail.MessageFlags;

import com.funambol.mailclient.CTPManager;
import com.funambol.mailclient.syncml.FolderData;
import com.funambol.mailclient.ui.view.ComposeMessageScreen;
import com.funambol.mailclient.ui.view.components.EditField;
import com.funambol.mailclient.Customization;
import com.funambol.mailclient.ui.view.DrawerFactory;
import com.funambol.syncml.spds.SyncException;
import com.funambol.syncml.spds.SourceConfig;
import com.funambol.syncml.protocol.SyncML;
import com.funambol.syncml.protocol.DevInf;
import com.funambol.syncml.protocol.Ext;

import com.funambol.util.ConsoleAppender;
import com.funambol.util.MailDateFormatter;
import com.funambol.util.RMSAppender;
import com.funambol.util.StringUtil;
import com.funambol.push.PushConfig;
import com.funambol.util.CodedException;
import com.funambol.util.ConnectionListener;
import com.funambol.util.ConnectionManager;
import com.funambol.util.ThreadPool;
import com.funambol.util.Log;
import com.funambol.util.MultipleAppender;
import com.funambol.util.SocketAppender;
import com.funambol.util.FileAppender;
import com.funambol.util.ThreadPoolMonitor;
import com.funambol.util.AppProperties;

import java.io.IOException;
import java.util.Calendar;
import java.util.Date;
import java.util.TimeZone;
import java.util.Vector;

import javax.microedition.io.ConnectionNotFoundException;
import javax.microedition.lcdui.Alert;
import javax.microedition.lcdui.AlertType;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.Display;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.Image;
import javax.microedition.midlet.MIDlet;
import javax.microedition.rms.RecordStoreException;


//#ifdef isBlackberry
//# import com.funambol.util.BlackberryUtils;
//# import net.rim.blackberry.api.browser.Browser;
//# import net.rim.blackberry.api.browser.BrowserSession;
//#endif

/**
 * It is the Controller class that controls all interactions
 * between screens and the model
 * It maintains a pool of shared UI instances
 */
public class UIController {

    private static final String TAG_LOG = "UIController";

    private static final int DEFAULT_ALERT_TIMEOUT = 3000; 
    private static final String RE = Localization.getMessages().RE_LABEL;
    private static final String FW = Localization.getMessages().FW_LABEL;
    public static final int CONNECTION_RETRY_TIME = 5;
    public static final int SENT_MESSAGE = 0;
    public static final int OUTGOING_MESSAGE = 1;
    public static final int INCOMING_MESSAGE = 2;
    public static final int COMMAND_TYPE = Command.OK;
    //Possible sync caller
    public static final int USER = 0;
    public static final int SAN_MESSAGE = 1;
    public static final int SCHEDULER = 2;
    public static final int CONNECTION_ERROR_TIMER = 3;
    public static int alarmCounter = 0;
    public static Funambol midlet;
    public static Display display;
    
    public static boolean isInboxReady = false;
    // The command pool
    //Blackberry gets low priority because softkeys include a back button. 
    //#ifdef isBlackberry
    //# public static Command backCommand = new Command(Localization.getMessages().BACK_COMMAND, Command.BACK, 99);
    //# public static Command lowLevelBackCommand = new Command(Localization.getMessages().BACK_COMMAND, Command.BACK, -10);
    //#else 
    public static Command backCommand =
            new Command(Localization.getMessages().BACK_COMMAND,
            Command.BACK, 0);
    public static Command lowLevelBackCommand =
            new Command(Localization.getMessages().BACK_COMMAND,
            Command.BACK, 0);
    //#endif
    public static Command selectCommand =
            new Command(Localization.getMessages().SELECT_COMMAND,
            UIController.COMMAND_TYPE, 0);
    public static Command cancelCommand =
            new Command(Localization.getMessages().CANCEL_COMMAND,
            Command.BACK, 10);
    public static Command saveCommand =
            new Command(Localization.getMessages().SAVE_COMMAND,
            UIController.COMMAND_TYPE, 1);
    public static Command inboxCommand =
            new Command(Localization.getMessages().INBOX_COMMAND,
            UIController.COMMAND_TYPE, 1);
    public static Command blackberryExitCommand = new Command(Localization.getMessages().EXIT_COMMAND_LABEL,
                                                              Command.EXIT, 200);
    public static Command nextCommand = new Command(Localization.getMessages().MESSAGE_VIEW_NEXT_MESSAGE,
                                                    UIController.COMMAND_TYPE, -2);
    public static Command previousCommand = new Command(Localization.getMessages().MESSAGE_VIEW_PREVIOUS_MESSAGE,
                                                        UIController.COMMAND_TYPE, -1);
    // The contact manager
    private static ContactManager contactManager;
    // The screen pool
    public static ComposeMessageScreen composeMessageScreen;
    public static LogViewerForm logViewerScreen;
    public static GeneralSettingsForm getMailSettingsScreen;
    private static InboxMessageList inboxMessageList;
    private static OutboxMessageList outboxMessageList;
    private static SentMessageList sentMessageList;
    private static DraftMessageList draftMessageList;
    protected static ContactList contactList;

    public static FileExplorerScreen fileExplorerScreen;
    // The current message view
    private static ViewMessageScreen viewMessageScreen;
    // The screen stack
    public static Stack backStack = new Stack();
    // Thread pool
    private static ThreadPool threadPool;
    private ThreadPoolMonitor uiThreadMonitor;
    private static final int MAX_NUM_THREADS = 5;
    public static MessageManager messageManager = MessageManager.getInstance();
    public static MailClientConfig mailClientConfig;
    // Folder informations
    private static Folder[] allFolders;
    public static boolean otaStarted;
    //public static long startAppProbe;
    public static long startupFreeMem;
    //private static long heapSize = Runtime.getRuntime().totalMemory();
    // private static ContactListLoader contactListLoader;
    private static MessageWriter messageWriter;
    private static PlatformRequestHandler prh;
    private static Drawer drawer;
    /** connection availability: if false the user must exit the application on:
     * Nokia and SonyEricsson;
     * Motorola For Linux OS;
     **/
    private static boolean offlineMode = false;

    public static AccountSettingsForm accountSettingsForm;

    /**
     * True if this is the first sync action for this application session
     * This force contacts sync at the first sync session performed by the
     * user.
     */
    public static boolean isFirstSync = true;
    private static ContactsLoader contactsLoader;
    //used for temporary bb fix 
    private static long lastTimeStarKeypressed = 0;
    private static AppProperties appProperties;
    private static ConnectionManager connectionManager = null;
    //The sync caller agent
    private static int syncCaller = USER;

    // Represents the current account:
    //  - MessageLists will show only Messages coming from this account
    //  - the compose screen will have this account as the default sender
    //  - it can be modified using the Accounts submenu
    private static AccountFolder currentAccount = null;

    //public static boolean WAP_SIMULATION = true;
    private UIController() {
    }

    public static void init(Funambol app) {
        Log.trace(TAG_LOG, "init");
        midlet = app;
        display = Display.getDisplay(app);
        initAppProperties(app);
        isFirstSync = true;
        connectionManager = ConnectionManager.getInstance();
    //#ifdef isBlackberry
    //# connectionManager.setConnectionListener(new UIConnectionListener());
    //#endif
    }

    /**
     * Initialized the AppProperties for the application. This method is
     * normally invoked by the init one, but in some unit tests, it needs to be
     * invoked separately.
     */
    public static void initAppProperties(MIDlet app) {
        appProperties = new AppProperties(app);
    }

    /**
     * Get a specific application property, using the appProperties component if 
     * possible, or directly using the MIDP interface otherwise. 
     * @param name
     * @return
     */
    public static String getProperty(String name) {
        Log.trace(TAG_LOG, "Getting property: " + name);
        String value = appProperties.get(name);
        // midlet should never be null in real applications, but in unit tests
        // it may happen that the UIController is not fully initialized, so we
        // check the value here
        if (value == null && midlet != null) {
            // Not able to read the property using AppProperties
            // read directly using the midlet
            value = midlet.getAppProperty(name);
        }
        Log.trace(TAG_LOG, "Property got: " + value);
        return value;
    }

    public static AppProperties getAppProperties() {
        Log.trace(TAG_LOG, "getProperties");
        return appProperties;
    }

    public static void initThreadPool() {
        Log.trace(TAG_LOG, "Initializing ThreadPool");
        ThreadPoolMonitor uiThreadMonitor = new UIThreadPoolMonitor();
        threadPool = new ThreadPool(uiThreadMonitor, MAX_NUM_THREADS);
        Log.trace(TAG_LOG, "ThreadPool Initialized");
    }

    public static ThreadPool getThreadPool() {
        Log.trace(TAG_LOG, "ThreadPool got");
        return threadPool;
    }

    public static void initLogger() {
        MultipleAppender appender = new MultipleAppender();

        // Set the appropriate appender and log level.
        String logAppender = getProperty(AppProperties.LOG_APPENDER);
        if (logAppender != null) {
            // trimming the property
            logAppender = logAppender.trim();
        }

        if ("console".equals(logAppender)) {
            appender.addAppender(new ConsoleAppender());
//#ifdef SOCKET_APPENDER
//#     } else if ("socket".equals(logAppender)) {
//#         String socketServer = midlet.getAppProperty(AppProperties.LOG_SOCKET_URL);
//#         appender.AddAppender(new SocketAppender(socketServer));
//#endif
        } else if ("file".equals(logAppender)) {
            String logFileUrl = midlet.getAppProperty(AppProperties.LOG_FILE_DIR_URL);
            // If the jad did not specify any log url, we use the photos dir
            if (logFileUrl == null) {
                logFileUrl = System.getProperty("fileconn.dir.photos");
            }
            if (logFileUrl != null) {
                FileAppender fa = new FileAppender(logFileUrl, "jamlog.txt");
                fa.setMaxFileSize(128 * 1024);
                appender.addAppender(fa);
            } else {
                // If file is not supported, we revert back to RMS
                //#expand int rmsSize = %RMS_LOG_MAX_SIZE%;
                RMSAppender rmsAppender = new RMSAppender(RMSAppender.LOGDBNAME, rmsSize);
                appender.addAppender(rmsAppender);
            }
        } else { // using rmsappender
            // If file is not supported, we revert back to RMS
            //#expand int rmsSize = %RMS_LOG_MAX_SIZE%;
            RMSAppender rmsAppender = new RMSAppender(RMSAppender.LOGDBNAME, rmsSize);
            appender.addAppender(rmsAppender);
        }

        // We init the logger to trace level to monitor the bootstrap, then we
        // will set the proper logging level.
        // Context errors handling is enabled per device with a window size that
        // is device dependent
        //#expand int logContextWindow = %LOG_CONTEXT_WINDOW%;
        if (logContextWindow == 0) {
            Log.initLog(appender, Log.TRACE);
        } else {
            Log.initLog(appender, Log.TRACE, logContextWindow);
            Log.setClientMaxLogLevel(Log.DEBUG);
        }
        Log.trace(TAG_LOG, "Log initialized");
    }

    /**
     * Get the permission connection: if false the client
     * cannot connect to the network
     * @return true if the connection has been granted by the user
     */
    public static boolean isSyncPermitted() {
        Log.trace(TAG_LOG, "isSyncPermitted,check begun");
        boolean result = (!isSyncInProgress()) && !isOfflineMode();  
        Log.trace(TAG_LOG, "isSyncPermitted value: " + result);
        return result;
    }

    /**
     * @return true if commands that performs online operations (like send log, 
     * get mail, update contacts etc.) can be used 
     */
    public static boolean isOkToAddOnlineCommands() {
        Log.trace(TAG_LOG, "isOkToAddOnlineCommands returned: " + isSyncPermitted());
        return isSyncPermitted();
    }

    /**
     * Set the offline mode for this app session: if true the client
     * cannot connect to the network.
     * changing the offline mode here will change also the CTPService online 
     * mode managed by the CTPManager instance
     * @param mode set the offline mode
     */
    protected static void setOfflineMode(boolean mode) {
        Log.trace(TAG_LOG, "setOfflineMode setting off-line mode to " + mode);
        offlineMode = mode;
        CTPManager.getInstance().setOfflineMode(mode);
        Log.trace(TAG_LOG, "setOfflineMode CTP Disconnected");
    }

    /**
     * 
     * @return true if the app is currently in offline mode
     */
    public static boolean isOfflineMode() {
        Log.trace(TAG_LOG, "isOfflineMode returning: " + offlineMode);
        return offlineMode;
    }

    /**
     * enable or disable the sync commands in different view screens
     *
     * @param enable enable the commands if true, disable the commands if false
     */
    public static void enableSyncCommands(boolean enable) {
        Log.info(TAG_LOG, "Enable Client's Sync Commands: " + enable);
        if (contactList != null) {
            contactList.enableSyncCommand(enable);
        }

        if (inboxMessageList != null) {
            getInboxMessageList().enableSyncCommand(enable);
        }

        if (composeMessageScreen != null) {
            getComposeMessageScreen().enableSendCommand(enable);
        }

        if (viewMessageScreen != null) {
            viewMessageScreen.enableFullMessageCommand(enable);
        }

        if (logViewerScreen != null) {
            logViewerScreen.enableSendCommand(enable);
        }

        if (accountSettingsForm != null) {
            accountSettingsForm.enableSaveCommand(enable);
        }
    }

    /**
     * enable / disable the sync commands, but keep settings "save" command 
     * always enabled
     * @param enable if true the commands will be enabled, if false 
     * the commands will be disabled
     */
    public static void enableSyncCommandsKeepingSettings(boolean enable) {
        Log.trace(TAG_LOG, "enableSyncCommandsKeepingSettings passing value: " + enable);
        enableSyncCommands(enable);
        if (!enable) {
            if (accountSettingsForm != null) {
                accountSettingsForm.enableSaveCommand(true);
            }
        }
    }

    /**
     * init the inbox: calls initmessagemanager, displays
     * the inbox with the cached messages, then starts the thread that loads the
     * messages from the rms
     *
     * @return true if the account has been set, false otherwise.
     * The account is considered set if the url is different from
     * Account.DEFAULT_URL and if the username and password are not empty.
     * (used by: Funambol)
     *
     */
    public static boolean initInbox() {
        Log.trace(TAG_LOG, "Initializing INBOX");
        boolean isAccountSet = false;

        try {
            inboxMessageList = new InboxMessageList(new Vector());
            outboxMessageList = null;
            draftMessageList = null;
            sentMessageList = null;

            isAccountSet = mailClientConfig.getUserAccount().isSet();

            // If the account information has been already set
            if (isAccountSet) {
                inboxMessageList.load();
                isInboxReady = true;
            } else {
                Log.info(TAG_LOG, "Config not set: going to account settings");

                showAlert(Localization.getMessages().CONFIG_NOT_SET,
                        AlertType.ERROR, false, getAccountSettingsForm(inboxMessageList));
                // setting minimum displayed message count
                inboxMessageList.setMinimumDisplayedMessageCount(
                        InboxMessageList.COUNT_NONE);
            }
        } catch (Exception ex) {
            Log.error(TAG_LOG, "initInbox exception occurred: " + ex);
            ex.printStackTrace();
        }
        Log.trace(TAG_LOG, "initInbox returning " + isAccountSet);
        return isAccountSet;
    }

    /**************** Multiple Email Account handling methods *****************/
    
    /**
     * Get the current account to be used by the folder lists
     * @return
     * (used by ComposeMessageScreen, InboxMessageList)
     */
    public static AccountFolder getCurrentMailAccount() {
        if(currentAccount == null) {
            AccountFolder[] accounts = messageManager.getAccounts();
            if(accounts.length > 0) {
                currentAccount = accounts[0];
            }
        }
        return currentAccount;
    }

    /**
     * Reset the current mail account to the default one
     * @return
     */
    private static void resetCurrentMailAccount() {
        currentAccount = null;
        getCurrentMailAccount();
    }

    /**
     * Set the current account
     * @param account
     * (used by InboxMessageList)
     */
    public static void setCurrentMailAccount(AccountFolder account, MessageList ml) {
        if(!currentAccount.equals(account)) {
            // If there is an active element, we shall remember it
            if (ml.size() > 0) {
                int index = ml.getActiveElementId();
                Message m = (Message) ml.getMessageAt(index);
                ml.setLastSelectedAccountMessage(currentAccount.getEmailAddress(), m);
            }
            // Update the current account
            currentAccount = account;
            ml.switchAccount();
        } else if(!isSyncInProgress()){
            ml.resetTitle();
        }
    }

    /**
     * Get and set the next available account to be used by the folder lists
     * (used by InboxMessageList)
     */
    public static void nextMailAccount(MessageList ml) {
        if(currentAccount == null) {
            getCurrentMailAccount();
        }
        AccountFolder[] accounts = messageManager.getAccounts();
        if(accounts.length == 0) {
            return;
        } 
        int currentIndex = getCurrentMailAccountIndex(accounts);
        if(currentIndex == accounts.length-1) {
            setCurrentMailAccount(accounts[0], ml);
        } else {
            setCurrentMailAccount(accounts[currentIndex+1], ml);
        }
    }

    /**
     * Get and set the previous available account to be used by the folder lists
     * (used by InboxMessageList)
     */
    public static void previousMailAccount(MessageList ml) {
        if(currentAccount == null) {
            getCurrentMailAccount();
        }
        AccountFolder[] accounts = messageManager.getAccounts();
        if(accounts.length == 0) {
            return;
        }
        int currentIndex = getCurrentMailAccountIndex(accounts);
        if(currentIndex == 0) {
            setCurrentMailAccount(accounts[accounts.length-1], ml);
        } else {
            setCurrentMailAccount(accounts[currentIndex-1], ml);
        }
    }

    private static int getCurrentMailAccountIndex(AccountFolder[] accounts) {
        for(int i=0; i<accounts.length; i++) {
            if(accounts[i].equals(currentAccount)) {
                return i;
            }
        }
        return 0;
    }

    /**
     * Suspend the current thread for the given number of seconds
     *
     * @param millis the time to wait (milliseconds)
     */
    public static void sleep(int millis) {
        Log.trace(TAG_LOG, "sleep suspending UIController Thread");
        try {
            Thread.sleep(millis);
        } catch (Exception e) {
            Log.error(TAG_LOG, "Exception occurred - Sleep interrupted: " + e);
        }
    }

    /**
     * init the messagemanager and the store
     * (used by Funambol)
     */
    public static void initMessageManager() {
        Log.trace(TAG_LOG, "Initializing MessageManager");
        try {
            messageManager = MessageManager.getInstance();
            initStore(false);
        } catch (Exception ex) {
            Log.error(TAG_LOG, "initMessageManager:Exception Occurred: " + ex);
            ex.printStackTrace();
        }

    }

    /**
     * init the message store
     * @param reset if true the folders will be erased and recreated
     */
    public static void initStore(boolean reset) throws MailException {
        Log.trace(TAG_LOG, "Initializing Store with value: " + reset);
        messageManager.initStore(reset);
        if (reset) {
            allFolders = null;
        }
        Log.trace(TAG_LOG, "Store Initialized");
    }

    //--------------------------------------------------------------------------
    // Methods to manage the views navigation
    //
    
    /**
     * This method retrieves the screen to go back from the Stack
     */
    public static void showBackScreen() /*throws Exception*/ {
        Log.trace(TAG_LOG, "showBackScreen");
        try {
            Displayable screen = backStack.pop();
            // If the screen is the inbox, cleanup the other screens
            if (screen == null) {
                Log.error(TAG_LOG, "The backstack has a null element. This should " +
                                   "not happen, bringing back to the inbox");
            }
            if (screen == inboxMessageList || screen == null) {
                showInboxScreen();
            } else {
                display.setCurrent(screen);
            }

        } catch (Exception ex) {
            Log.error(TAG_LOG, "showBackScreen Exception Occurred: " + ex.toString());
            showInboxScreen();
        }
    }

    /**
     * show the current composeMessageScreen, performing no updates. <br/>
     * @param backScreen the screen that needs to be bounded to the back button
     * in the compose message screen
     * @param CustomItem the item that will be focused
     *
     * if you need to update the messagescreen use updateComposeMessageScreen
     * functions
     **/
    public static void showComposeMessageScreen(Displayable backScreen, EditField item) {
        Log.trace(TAG_LOG, "showComposeMessageScreen Item to set: " + item);
        if (backScreen != null) {
            backStack.push(backScreen);
        } else {
            backStack.push(inboxMessageList);
        }

        display.setCurrent(getComposeMessageScreen());
        getComposeMessageScreen().setDefaultTitle();
        
        getComposeMessageScreen().resetBodyTofirstLine();

        getComposeMessageScreen().activateItem(item);

        Log.trace(TAG_LOG, "showComposeMessageScreen Current item: " + item);
    }

    public static void notifyNewOptionalUpdate(String version) {
        Log.trace(TAG_LOG, "Optional Update Notification");
        UpdateAlert alert = new UpdateAlert(false, version);
        alert.showModal(display);
        inboxMessageList.enableUpdateCommand(true);
        Log.trace(TAG_LOG, "notifyNewOptionalUpdate:Update Command Enabled");
    }
    
    public static void notifyNewRecommendedUpdate(String version) {
        Log.trace(TAG_LOG, "Recommended Update Notification");
        UpdateAlert alert = new UpdateAlert(true, version);
        alert.showModal(display);
        inboxMessageList.enableUpdateCommand(true);
        Log.trace(TAG_LOG, "notifyNewRecommendedUpdate:Update Command Enabled");
    }

    public static void update() {
        Log.trace(TAG_LOG, "Update Command sent");
        UIController.openUrl(UpdaterManager.getInstance().getDownloadUrl());
    }

    /**
     * show the compose message screen ready for a new message to be composed
     */
    public static void composeNewMessage(Displayable backScreen) {
        Log.trace(TAG_LOG, "composeNewMessage");
        if (!contactsLoader.isLocked()) {
            Message m = new Message();
            getComposeMessageScreen().setMessage(new Message());
            // we need to set the message here, because
            // composemessagescree.setmessage does not
            // (for speed reasons)
            getContactList().setMessage(m);
            getContactList().emptySearchString();
            getContactList().SortAlphabetically();
            showContactList(display.getCurrent());
        } else {
            showErrorAlert(
                    Localization.getMessages().CONTACTSLOADER_LOCKED_ERROR,
                    backScreen);
        }
    }

    /**
     * update ComposeMessageScreen message.
     * the message remains unchanged
     **/
    public static void updateComposeMessageScreen(Message message) {
        Log.trace(TAG_LOG, "updateComposeMessageScreen:Setting a Message");
        getComposeMessageScreen().setMessage(message);
    }

    /**
     * update ComposeMessageScreen toAppend string.
     * the toAppend string remains unchanged
     **/
    public static void updateComposeMessageScreen(String toAppend) {
        Log.trace(TAG_LOG, "updateComposeMessageScreen:Appending a String");
        getComposeMessageScreen().setToAppend(toAppend);
    }

    /**
     * update ComposeMessageScreen toAppend string and message
     **/
    public static void updateComposeMessageScreen(Message message, String toAppend) {
        Log.trace(TAG_LOG, "updateComposeMessageScreen:Msg and String");
        updateComposeMessageScreen(message);
        updateComposeMessageScreen(toAppend);
    }

    /**
     * return the composemessageform and create it if needed
     */
    public static ComposeMessageScreen getComposeMessageScreen() {
        Log.trace(TAG_LOG, "getComposeMessageScreen:Getting Screen");
        if (composeMessageScreen == null) {
            composeMessageScreen = new ComposeMessageScreen();
        }
        
        return composeMessageScreen;
    }

    /**
     *  show the inbox screen, cleaning the stack and freeing not used objects
     * and memory
     */
    public static void showInboxScreen() {
        Log.trace(TAG_LOG, "showInboxScreen:Getting Screen");
        backStack.clear();
        outboxMessageList = null;
        sentMessageList = null;
        draftMessageList = null;
        composeMessageScreen = null;

        if (!isSyncInProgress()) {
            getInboxMessageList().resetTitle();
        }

        display.setCurrent(getInboxMessageList());
    //#ifdef low_mem
//#         freeMemory();
    //#endif
    }

    /** If the freeMemory is low, try to collect some memory */
    public static long freeMemory() {
        long mem = Runtime.getRuntime().freeMemory();
        
        Log.trace(TAG_LOG, "Free Memory: " + mem);
        if (mem < 10000) {
            Log.info(TAG_LOG, ">> freeMemory is low: " + Runtime.getRuntime().freeMemory());
            try {
                System.gc();
                Thread.sleep(1);
            } catch (InterruptedException ex) {
                // just ignore it
                Log.error(TAG_LOG, "interrupted exception freeing memory");

            }

            mem = Runtime.getRuntime().freeMemory();
        }

        Log.trace(TAG_LOG, "Free Memory after GC call: " + mem);
        return mem;
    }

    /**
     * Display the outbox screen.
     */
    public static void showOutboxScreen(Displayable backScreen) {
        Log.trace(TAG_LOG, "showOutboxScreen Showing Screen");
        backStack.push(backScreen);
        //TODO: use lazy initInbox
        updateOutboxMessageList(null);
        display.setCurrent(getOutboxMessageList());
    }

    /**
     * push current screen in the backstack and display the sent message list
     *
     *@param backscreen the displayable to be pushed in the stack,
     * often the current displayable
     */
    public static void showSentScreen(Displayable backScreen) {
        Log.trace(TAG_LOG, "showSentScreen");
        backStack.push(backScreen);
        updateSentMessageList(null);
        UIController.display.setCurrent(getSentMessageList());
    }

    /**
     * push current screen in the backstack and display the draft message list
     *
     *@param backscreen the displayable to be pushed in the stack,
     * often the current displayable
     */
    public static void showDraftScreen(Displayable backScreen) {
        Log.trace(TAG_LOG, "showDraftScreen");
        backStack.push(backScreen);
        updateDraftMessageList(null);
        UIController.display.setCurrent(getDraftMessageList());
    }

    /**
     * push current screen in the backstack and display the view message screen
     * with the given message.
     *<br>
     *the message read flag will be set to true if needed
     *
     *
     *
     * @param backscreen the displayable to be pushed in the stack,
     * often the current displayable
     * @param message the message to be displayed
     * @param attachReadOnly if from view of the message you can see only
     * attachments list without open, add or remove the files.
     */
    public static void showViewMessageScreen(Displayable backScreen, Message message, boolean attachReadOnly) {
        Log.trace(TAG_LOG, "showViewMessageScreen");
        backStack.push(backScreen);
        Log.debug(TAG_LOG, "showViewMessageScreen OPENED Flag is " + message.getFlags().isSet(MessageFlags.OPENED));
        if (!message.getFlags().isSet(MessageFlags.OPENED)) {
            changeReadFlag(message);
        }

        if (viewMessageScreen == null) {
            viewMessageScreen = new ViewMessageScreen(message, attachReadOnly);
        } else {
            viewMessageScreen.update(message, attachReadOnly);
        }
        
        if (!contactsLoader.isLocked()) {
            viewMessageScreen.enableCallCommand();
        }

        viewMessageScreen.resetBodyTofirstLine();
        display.setCurrent(viewMessageScreen);
    }

    public static void enableCallSenderCommand() {
        Log.trace(TAG_LOG, "enableCallSenderCommand:Enabling call sender");
        if (display.getCurrent() instanceof ViewMessageScreen) {
            viewMessageScreen.enableCallCommand();
        }

    }

    /**
     * opens a list of links in the given message body
     * @param body the string to be searched for links
     * @param backscreen the displayable to be pushed in the stack,
     * often the current displayable
     *
     */
    public static void showLinkList(Displayable displayable, String body) {
        Log.trace(TAG_LOG, "showLinkList");
        backStack.push(displayable);
        display.setCurrent(new LinkList(body));
    }

    /**
     * Show account settings form
     * @param backscreen the displayable to be pushed in the stack,
     * often the current displayable
     *
     */
    public static void showAccountSettings(Displayable displayable) {
        Log.trace(TAG_LOG, "showAccountSettings");
        accountSettingsForm = getAccountSettingsForm(displayable);
        accountSettingsForm.layout();
        display.setCurrentItem(accountSettingsForm.getFocusedItem());
    }

    /**
     * @return the account settings form
     * @param backscreen the displayable to be pushed in the stack,
     * often the current displayable
     */
    public static AccountSettingsForm getAccountSettingsForm(
            Displayable displayable) {
        Log.trace(TAG_LOG, "getAccountSettingsForm");
        backStack.push(displayable);
        if (accountSettingsForm == null) {
            accountSettingsForm = new AccountSettingsForm();
        }

        return accountSettingsForm;
    }

    /**
     * show the mail sync settings form
     * @param backscreen the displayable to be pushed in the stack,
     * often the current displayable
     */
    public static void showMailSyncSettings(Displayable displayable) {
        Log.trace(TAG_LOG, "showMailSyncSettings");
        backStack.push(displayable);
        if (getMailSettingsScreen == null) {
            getMailSettingsScreen = new GeneralSettingsForm();
        }

        display.setCurrent(getMailSettingsScreen);
    }

    /**
     * show the log view form
     * @param backscreen the displayable to be pushed in the stack,
     * often the current displayable
     */
    public static void showLogViewer(Displayable displayable) {
        Log.trace(TAG_LOG, "showLogViewer");
        backStack.push(displayable);
        logViewerScreen =
                new LogViewerForm();
        display.setCurrent(logViewerScreen);
    }

    /**
     * show the recipient list form
     * @param backscreen the displayable to be pushed in the stack,
     * often the current displayable
     */
    public static void showRecipientsList(Displayable displayable, Message message) {
        Log.trace(TAG_LOG, "showRecipientsList");
        backStack.push(displayable);
        display.setCurrent(new RecipientList(message));
    }

    /**
     * show the contact list
     * @param backscreen the screen to be put in the stack for future back commands
     */
    public static void showContactList(Displayable backScreen) {
        Log.trace(TAG_LOG, "showContactList");
        if (!contactsLoader.isLocked()) {
            backStack.push(backScreen);
            getContactList().rewindList();
            getContactList().resetSubtitle();
            display.setCurrent(getContactList());
        } else {
            //show alert to inform the user that the contact list is needed 
            //to perform this operation and he must wait the full contacts 
            //cache loading
            showErrorAlert(
                    Localization.getMessages().CONTACTSLOADER_LOCKED_ERROR,
                    backScreen);

        }

    }

    public static void showAddContactScreen(Displayable displayable,
            ContactList addressList) {
        Log.trace(TAG_LOG, "showAddContactScreen with address list");
        backStack.push(displayable);
        display.setCurrent(new AddContactForm(addressList));
    }

    public static void showAddContactScreen(Displayable displayable) {
        Log.trace(TAG_LOG, "showAddContactScreen");
        showAddContactScreen(displayable, (ContactList) null);
    }

    public static void showScreen(Displayable toDisplay, Displayable toHide) {
        Log.trace("[UIcontroller.showEditorForm]Showing screen given contact");
        backStack.push(toHide);
        display.setCurrent(toDisplay);                
    }

    public static void showScreenWithBackStack(Displayable toDisplay) {
        Displayable toHide = display.getCurrent();
        showScreen(toDisplay, toHide);
    }

    public static void showScreenNoBackStack(Displayable toDisplay) {
        display.setCurrent(toDisplay);                
    }
    
    public static void showAddContactScreen(Displayable displayable, Contact contact) {
        Log.trace(TAG_LOG, "showAddContactScreen with given contact");
        backStack.push(displayable);
        UIController.display.setCurrent(new AddContactForm(contact, getContactList(), AddContactForm.MODE_ADD_CONTACT));
    }

    /**
     * displays a edit contact screen and update the given FunAddressList after
     * the edit.
     *
     *
     * @param displayable: the displayable to be pushed in the stack
     * contact: the contact to be edited
     * contactList: the adddresslist to be updated (can be null if not needed)
     */
    public static Displayable showEditContactScreen(
            Displayable displayable,
            Contact contact, ContactList contactList, int mode) {
        Log.trace(TAG_LOG, "showEditContactScreen");
        backStack.push(displayable);
        Displayable contactForm = new AddContactForm(contact, contactList, mode);
        UIController.display.setCurrent(contactForm);
        return contactForm;
    }


    public static void showAlertDetails(String message) {
        AlertDetailsScreen detailsScreen = new AlertDetailsScreen(message);
        Displayable c = display.getCurrent();
        backStack.push(c);
        display.setCurrent(detailsScreen);
    }

    /**
     * Show an info alert with autodismiss
     */
    public static void showAlert(String message) {
        Log.trace(TAG_LOG, "showAlert (INFO)");
        showAlert(message, AlertType.INFO, true);
    }

    /**
     * Show an info alert with autodismiss and a displayable
     * to open after it's been dismissed.
     */
    public static void showAlert(String message, Displayable displayable) {
        Log.trace(TAG_LOG, "showAlert (INFO alert given displayable)");
        showAlert(message, AlertType.INFO, true, displayable);
    }

    /**
     * Show an error alert without autodismiss
     */
    public static void showErrorAlert(String message) {
        Log.trace(TAG_LOG, "showErrorAlert (ERROR)");
        showAlert(message, AlertType.ERROR, false);
    }

    /**
     * Show an error alert with details command for longer message
     */
    public static void showErrorDetailedAlert(String message, String longMessage) {
        Log.trace(TAG_LOG, "showErrorDetailedAlert");
        showAlert(message, longMessage, AlertType.ERROR, false, null, false);
    }

    /**
     * Show an info alert without autodismiss
     */
    public static void showInfoAlert(String message) {
        Log.trace(TAG_LOG, "showInfoAlert");
        showAlert(message, AlertType.INFO, false);
    }

    /**
     * Show an info alert without autodismiss
     */
    public static void showInfoAlert(String title, String message) {
        Log.trace(TAG_LOG, "showInfoAlert");
        showAlert(title, message, null, AlertType.INFO, false, null, false);
    }


    /**
     * Show an error alert without autodismiss and a displayable
     * to open after it's been dismissed.
     */
    public static void showErrorAlert(String message, Displayable displayable) {
        Log.trace(TAG_LOG, "showErrorAlert");
        showAlert(message, AlertType.ERROR, false, displayable);
    }

    /**
     * Show an alert with given message, alert type and autodismiss.
     * This is the generic method called by the others.
     */
    private static void showAlert(String message, AlertType alertType, boolean autoDismiss) {
        showAlert(message, null, alertType, autoDismiss, null, false);
    }

    public static void showAlert(String message, AlertType alertType,
            boolean autoDismiss, Displayable displayable) {

        showAlert(message, null, alertType, autoDismiss, displayable, false);
    }

    private static void showConfirmationDialog(String title, String message, PopupAction action) {
        showConfirmationDialog(title, message, action, null, null);
    }

    private static void showConfirmationDialog(String title, String message,
                                               PopupAction action, String okLabel,
                                               String cancelLabel) {
        Displayable c = display.getCurrent();
        Image snapshot = null;
        if (c instanceof AlertableScreen) {
            AlertableScreen as = (AlertableScreen)c;
            try {
                snapshot = as.takeSnapshot();
            } catch (Exception e) {
                Log.error(TAG_LOG, "Cannot take snapshot " + e.toString());
            }
        }

        if (title == null) {
            title = Localization.getMessages().CONFIRMATION_TITLE;
        }

        AlertScreen screen = new AlertScreen(snapshot, AlertScreen.CONFIRMATION_YES_NO,
                                             title,
                                             message, null, false, 0, null, action);
        if (okLabel != null) {
            screen.setYesLabel(okLabel);
        }
        if (cancelLabel != null) {
            screen.setNoLabel(cancelLabel);
        }

        screen.show();
    }

    public static void showAlert(String message, String detailsMessage,
                                 AlertType alertType, boolean autoDismiss,
                                 Displayable displayable, boolean modal) {
        showAlert(null, message, detailsMessage, alertType, autoDismiss,
                  displayable, modal);
    }



    /**
     * Show an alert with given message, alert type, autodismiss and next displayable
     */
    public static void showAlert(String title, String message, String detailsMessage,
                                 AlertType alertType, boolean autoDismiss,
                                 Displayable displayable, boolean modal) {
        Log.trace(TAG_LOG, "showAlert Showing alert given all parameters");

        Displayable c = display.getCurrent();
        Image snapshot = null;
        if (c instanceof AlertableScreen) {
            try {
                AlertableScreen as = (AlertableScreen)c;
                snapshot = as.takeSnapshot();
            } catch (Exception e) {
                Log.error(TAG_LOG, "Cannot take snapshot " + e.toString());
            }
        }

        int timeout;
        if (autoDismiss) {
            timeout = DEFAULT_ALERT_TIMEOUT;
        } else {
            timeout = AlertScreen.FOREVER;
        }

        int type;
        if (AlertType.ERROR == alertType) {
            type  = AlertScreen.INFORMATION_OK;
        } else {
            type  = AlertScreen.INFORMATION_OK;
        }


        // Build the default title if not provided
        if (title == null) {
            if (AlertType.ERROR == alertType) {
                title = Localization.getMessages().ERROR_ALERT_TITLE;
            } else {
                title = Localization.getMessages().INFO_ALERT_TITLE;
            }
        }


        AlertScreen screen = new AlertScreen(snapshot, type, title,
                                             message, detailsMessage, false, timeout,
                                             displayable, null);
        screen.show();
    }

    /**
     * Show a modal alert. The method does not return until the user closes the
     * alert.
     *
     * @param message the message to display
     */
    public static void showModalAlert(String message) {
        Log.trace(TAG_LOG, "showModalAlert");
        showAlert(message, null, AlertType.INFO, false, null, true);
    }

    public static void showAbout(Displayable displayable) {
        Log.trace(TAG_LOG, "showAbout");
        backStack.push(displayable);
        display.setCurrent(new AboutScreen());
    }

    /**
     * Utilites methods managing the Model
     */
    public static void replyMessage(Message message) {
        Log.trace(TAG_LOG, "replyMessage");
        Message replyMessage = new Message();
        //TODO: exception handling
        try {
            replyMessage.setTo(message.getReplyTo());
            replyMessage.setSubject(RE + message.getSubject());
        } catch (MailException ex) {
            ex.printStackTrace();
            Log.error(TAG_LOG, "unable to set content into reply " +
                    "message, error getting 'from' field from message");
        }

        setDelayedFlag(message, MessageFlags.ANSWERED);
        updateComposeMessageScreen(replyMessage, getReplyText(message));
        // getContactList().emptySearchString();
        showComposeMessageScreen(display.getCurrent(), 
                getComposeMessageScreen().getBody());
    }

    /**
     * Put the application in background. This method does not work for any
     * device.
     */
    public static void background() {
        Log.trace(TAG_LOG, "Putting the app in background");
        // This works only on some devices. Shall we use ifdefs?
        backStack.clear();
        display.setCurrent(null);

        // This aims to fix the bug on Nokia Series 60 5th edition devices about
        // the screen flashing when putting the application in background.
        try {
            //#expand int sleepBeforeHide = %SLEEP_BEFORE_HIDE%;
            Thread.sleep(sleepBeforeHide);
        } catch(Exception ex) { /* Nothing to do */ }
    }

    /**
     * set the message as the original message in composemessagescreen, the next
     * time the send / sendlater commandaction is performed the given flag will
     * be set to true
     *
     * @param message the message to be set as the original message in
     * composemessageform
     *
     * @param flag the flag (one of MessageFlags constants) to be set to true
     */
    private static void setDelayedFlag(final Message message,
            final int flag) {
        Log.trace(TAG_LOG, "setDelayedFlag");
        //Log.debug("UIController: trying to set read message flag");
        //setRepliedFlag(message);
        MessageFlags flags = new MessageFlags();
        flags.setFlags(message.getFlags().getFlags());
        if (!flags.isSet(flag)) {
            Log.debug(TAG_LOG, "Delayed flag added");
            //>>>>FIXME: Transfer on ComposeMessageForm
            getComposeMessageScreen().setMessageFlag(flag);
            //messageManager.getInstance().updateMessageFlag(message, flag, true);
            try {
                Log.debug(TAG_LOG, "message: " + message);
                getComposeMessageScreen().setOriginalMessage(message);
            } catch (MailException ex) {
                Log.error(TAG_LOG, "error forwarding message while creating messageinfo " +
                        "from original message");
                ex.printStackTrace();
            }

        }
    }

    /**
     * create a new forward message and show the compose message screen
     *
     * @param message the message to be forwarded (body content will be appended
     * at the bottom of the email)
     */
    public static void forwardMessage(Message message) {
        Log.trace(TAG_LOG, "forwardMessage");

        Message forwardMessage = new Message();

        forwardMessage.setSubject(FW + message.getSubject());
        setDelayedFlag(message, MessageFlags.FORWARDED);
        UIController.updateComposeMessageScreen(forwardMessage, getForwardText(message));
        getContactList().emptySearchString();
        getContactList().setMessage(forwardMessage);
        getContactList().emptySearchString();
        getContactList().SortAlphabetically();
        showContactList(display.getCurrent());
    }

    /**
     * update the message list that contain the given message
     *
     * @param message the message
     */
    private static void updateMessageList(Message message) {
        Log.trace(TAG_LOG, "updateMessageList");
        if (message.getParent() == null) {
            //updateAllMessageLists(message);
            Log.error(TAG_LOG, "updateMessageList:Message without parent");
            return;
        } else {
            if (message.getParent().getRole().equals(FolderData.INBOX_ROLE)) {
                Log.debug(TAG_LOG, "updateMessageList: message from inbox, updating inbox");
                updateInboxMessageList(message);
            } else if (message.getParent().getRole().equals(FolderData.OUTBOX_ROLE)) {
                Log.debug(TAG_LOG, "updateMessageList message from outbox, updating outbox");
                updateOutboxMessageList(message);
            } else if (message.getParent().getRole().equals(FolderData.SENT_ROLE)) {
                Log.debug(TAG_LOG, "updateMessageList message from sent, updating sent");
                updateSentMessageList(message);
            } else if (message.getParent().getRole().equals(FolderData.DRAFTS_ROLE)) {
                Log.debug(TAG_LOG, "updateMessageList message from draft, updating draft");
                updateDraftMessageList(message);
            } else {
                Log.error(TAG_LOG, "updateMessageList Unkown folder");
            }
        }

    }

    public static void updateMessageList(Object o, String role) {
        Log.trace(TAG_LOG, "updateMessageList:Updating given role");
        MessageList messageList;
        if (role.equals(FolderData.INBOX_ROLE)) {
            messageList = getInboxMessageList();
        } else if (role.equals(FolderData.OUTBOX_ROLE)) {
            messageList = getOutboxMessageList();
        } else if (role.equals(FolderData.DRAFTS_ROLE)) {
            messageList = getDraftMessageList();
        } else if (role.equals(FolderData.SENT_ROLE)) {
            messageList = getSentMessageList();
        } else {
            messageList = getInboxMessageList();
        }
        if (o == null) {
            messageList.resetTitle();
            if(!role.equals(FolderData.INBOX_ROLE)) {
                messageList.setMessageList(getSortedMessages(
                        messageManager.getFoldersFromRole(role)));
            } else {
                messageList.setMessageList(getSortedMessages(
                        messageManager.getAccountFolderFromRole(currentAccount, role)));
            }
        } else if (o instanceof Message) {
            if(!role.equals(FolderData.INBOX_ROLE)) {
                messageList.setMessageList(getSortedMessages(
                        messageManager.getFoldersFromRole(role)));
            } else {
                messageList.setMessageList(getSortedMessages(
                        messageManager.getAccountFolderFromRole(currentAccount, role)));
            }
        } else if (o instanceof String) {
            if (o.toString().length() == 0) {
                messageList.resetTitle();
            } else {
                messageList.setTitle(o.toString());
            }
        }
    }

    public static void updateDraftMessageList(Object o) {
        Log.trace(TAG_LOG, "updateDraftMessageList");
        updateMessageList(o, FolderData.DRAFTS_ROLE);
    }

    public static void updateSentMessageList(Object o) {
        Log.trace(TAG_LOG, "updateSentMessageList");
        updateMessageList(o, FolderData.SENT_ROLE);
    }

    public static void updateInboxMessageList(Object o) {
        Log.trace(TAG_LOG, "updateInboxMessageList");
        updateMessageList(o, FolderData.INBOX_ROLE);
    }

    public static void updateOutboxMessageList(Object o) {
        Log.trace(TAG_LOG, "updateInboxMessageList");
        updateMessageList(o, FolderData.OUTBOX_ROLE);
    }

    /**
     * open a url.
     *
     * @param url the url to be opened in the default browser (device dependent)
     */
    public static void openUrl(String url) {
        Log.trace(TAG_LOG, "Opening url: [" + url + "]");

        // In Nokia S60 device the platformRequest
        // doesn't open link without "http://"
        if (!url.startsWith("http")) {
            url = "http://" + url;
        }

        //#ifdef isBlackberry
        //# BrowserSession bSession = Browser.getDefaultSession();
        //# bSession.displayPage(url);
        //#else
        try {
            midlet.platformRequest(url);
        } catch (ConnectionNotFoundException ex) {
            ex.printStackTrace();
            Log.error(TAG_LOG, "Cannot openUrl (1): " + ex.toString());
            showErrorAlert(Localization.getMessages().ERROR_OPENING_URL);
        } catch (Exception e) {
            e.printStackTrace();
            Log.error(TAG_LOG, "Cannot openUrl (2): " + e.toString());
        }
        //#endif
    }

    public static void dialNumber(String number) {
        Log.trace(TAG_LOG, "Dialing: " + number);
        try {
            doPlatformRequest("tel:" + number);
        } catch (Exception ex) {
            Log.error(TAG_LOG, "dialNumber:Exception occurred: " + ex);
            ex.printStackTrace();
        }

    }

    /**
     * save tha given contact
     *
     * @param contact the contact to be saved
     * @param isNew true if contact is new, false if editing existent contact
     * @trows AlreadyExistentContactException if contact already exists
     */
    public static void saveContact(Contact contact, boolean isNew)
            throws ContactManagerException, AlreadyExistentContactException {
        Log.trace(TAG_LOG, "Saving: " + contact.getVisibleName() + " - New: " + isNew);
        if (isNew) {

            Contact existentContact = contactManager.exists(contact.getDefaultEmail());
            if (existentContact != null) {
                throw new AlreadyExistentContactException(existentContact);
            }

            contactManager.addContact(contact, true);
        } else {
            contactManager.updateContact(contact);
        }

    }

    public synchronized static Vector getSortedMessages(
            String folderPath) {
        Log.trace(TAG_LOG, "getSortedMessages:Folder: " + folderPath);
        Folder folder = messageManager.getFolder(folderPath, true);
        return getSortedMessages(folder);
    }

    public synchronized static Vector getSortedMessages(
            Folder[] folders) {
        Log.trace(TAG_LOG, "getSortedMessages: Given the folders");
        Vector list = new Vector();
        try {
            for(int i=0; i<folders.length; i++) {
                Vector messages = messageManager.getMessagesInFolder(folders[i], null);
                for (int j=0; j<messages.size(); ++j) {
                    list.addElement(messages.elementAt(j));
                }
            }
            if (list.size() > 0) {
                list = bubbleSortPerDate(list);
            }
            Log.stats("[UIcontroller.getSortedMessages]end get sorted messages ");
            return list;
        } catch (Exception ex) {
            Log.error(TAG_LOG, "getSortedMessages:Error occurred sorting message list: " + ex);
            Log.stats("[UIcontroller.getSortedMessages]Exiting getsortedMessages with exception");
            ex.printStackTrace();
            return list;
        }
    }

    /**
     * getSortedMessages is synchronized to avoid potential issues
     * on concurrent access to the INbox elements in the storage
     * @return a sorted messageinfo with items from the given folderinfo
     */
    public synchronized static Vector getSortedMessages(
            Folder folder) {
        Log.trace(TAG_LOG, "getSortedMessages:Given the folder");
        Log.stats("[UIcontroller.getSortedMessages]starting get sorted messages ");
        Vector list = new Vector();
        try {
            Vector messages = messageManager.getMessagesInFolder(folder, null);

            for (int j=0; j<messages.size(); ++j) {
                list.addElement(messages.elementAt(j));
            }
            if (list.size() > 0) {
                list = bubbleSortPerDate(list);
            }
            Log.stats("[UIcontroller.getSortedMessages]end get sorted messages ");
            return list;
        } catch (Exception ex) {
            Log.error(TAG_LOG, "getSortedMessages:Error occurred sorting message list: " + ex);
            Log.stats("[UIcontroller.getSortedMessages]Exiting getsortedMessages with exception");
            ex.printStackTrace();
            return list;
        }
    }

    /**
     * A sort algorithm to order the messages in the view Inbox as per sent date
     */
    public static Vector bubbleSortPerDate(Vector list) {
        Log.trace(TAG_LOG, "Sorting list");
        int n = list.size();

        for (int pass = 1; pass < n; pass++) {  // count how many times
            // This next loop becomes shorter and shorter

            for (int i = 0; i < n - pass; i++) {
                Message msg1 = (Message) list.elementAt(i);
                Message msg2 = (Message) list.elementAt(i + 1);
                long received1 = msg1.getReceivedTime();
                long received2 = msg2.getReceivedTime();
                if (received1 < received2) {
                    // exchange elements
                    Object temp = list.elementAt(i);
                    list.setElementAt(list.elementAt(i + 1), i);
                    list.setElementAt(temp, i + 1);
                }
            }
        }
        Log.trace(TAG_LOG, "Returning sorted list");
        return list;
    }

    /**
     * reset the account deleting the store and startng a new
     * refresh_from_server sync
     */
    public static void resetAccount() {
        Log.trace(TAG_LOG, "Resetting");
        try {
            //notify inbox of the accounts that are going to be deleted
            AccountFolder[] accounts = messageManager.getAccounts();
            for(int i=0; i<accounts.length; i++) {
                getInboxMessageList().accountRemoved(accounts[i]);
            }

            //delete message store
            messageManager.initStore(true);

            resetCurrentMailAccount();

            //delete contact list and related PIM Item Queue
            if (contactManager == null) {
                contactManager = ContactManagerFactory.getContactManager(
                        ContactManager.RMS_TYPE);
            }

            // reset the inbox view
            resetInboxMessageList();
            showInboxScreen();

            // empty the contact list (to free memory)
            // The contactManager may still hold a reference to an old
            // message that got deleted in the previous cleanup
            // We clean that information to avoid dangling references
            if (contactList != null) {
                contactList.resetContactList(new Message());
            }
            contactManager.resetContactList();

            //initialize new account's messages and contacts
            sync(SyncML.ALERT_CODE_REFRESH_FROM_SERVER, true);
            getInboxMessageList().setMinimumDisplayedMessageCount(
                    InboxMessageList.COUNT_NONE);
        } catch (RecordStoreException rse) {
            Log.error(TAG_LOG, "resetAccount:Exception occurred: " + rse.toString());
            // TODO: ALERT ??
            showInboxScreen();
        } catch (MailException me) {
            Log.error(TAG_LOG, "resetAccount:Exception occurred: " + me.toString());
            // TODO: ALERT ??
            showInboxScreen();
        }

    }

    /**
     * show the inbox and requests a refresh from server sync
     */
    public static void resetInboxFromServer()
            throws RecordStoreException, MailException {
        Log.trace(TAG_LOG, "resetInboxFromServer:Resetting");
        getInboxMessageList().rewindList();
        showInboxScreen();
        Log.debug(TAG_LOG, "starting refresh from server...");
        sync(SyncML.ALERT_CODE_REFRESH_FROM_SERVER, false);
    }

    /**
     * Information on SyncClient status:
     * @return boolean false if some thread is sync'ing
     */
    public static boolean isSyncInProgress() {
        Log.trace(TAG_LOG, "isSyncInProgress:checking");
        return SyncClient.getSyncClient().isBusy();
    }

    /**
     * reinit the contacts from server
     */
    public static void resetContacts() {
        Log.trace(TAG_LOG, "Resetting contacts");

        if (contactList != null) {
            contactList.resetContactList(new Message());
            contactList.setContactCount(0);
        }
        // TODO: attach listener
        sync(SyncClient.CONTACTS, SyncML.ALERT_CODE_REFRESH_FROM_SERVER);

    }

    public static void updateLogLevel(int logLevel) {
        Log.trace(TAG_LOG, "Updating log level to: " + logLevel);
        Log.setLogLevel(logLevel);

        //read the configuration before saving it
        try {
            mailClientConfig = ConfigManager.getConfig();
        } catch (Exception e) {
            Log.error(TAG_LOG, "updateLogLevel:Exception reading configuration:" + e);
        }

        mailClientConfig.setLogLevel(logLevel);
        saveNewConfig(mailClientConfig);
    }

    public static InboxMessageList getInboxMessageList() {
        Log.trace(TAG_LOG, "getInboxMessageList");
        if (inboxMessageList == null) {
            inboxMessageList = new InboxMessageList(new Vector());
        }
        return inboxMessageList;
    }

    public static OutboxMessageList getOutboxMessageList() {
        Log.trace(TAG_LOG, "getOutboxMessageList");
        if (outboxMessageList == null) {
            outboxMessageList = new OutboxMessageList(getSortedMessages(
                    messageManager.getFoldersFromRole(FolderData.OUTBOX_ROLE)));
        }
        return outboxMessageList;
    }

    public static SentMessageList getSentMessageList() {
        Log.trace(TAG_LOG, "getSentMessageList");
        if (sentMessageList == null) {
            sentMessageList = new SentMessageList(getSortedMessages(
                    messageManager.getFoldersFromRole(FolderData.OUTBOX_ROLE)));
        }
        return sentMessageList;
    }

    public static DraftMessageList getDraftMessageList() {
        Log.trace(TAG_LOG, "getDraftMessageList");
        if (draftMessageList == null) {
            draftMessageList = new DraftMessageList(getSortedMessages(
                    messageManager.getFoldersFromRole(FolderData.OUTBOX_ROLE)));
        }
        return draftMessageList;
    }

    public static void changeFollowUpFlag(Message message) {
        Log.trace(TAG_LOG, "changeFollowUpFlag");
        changeFlag(message, MessageFlags.FLAGGED);
    }

    public static void changeReadFlag(Message message) {
        Log.trace(TAG_LOG, "changeReadFlag");
        changeFlag(message, MessageFlags.OPENED);
    }

    public static void closeApp() {
        Log.info(TAG_LOG, "Closing application");
        PopupAction action = new ExitPopupAction();
        showConfirmationDialog(Localization.getMessages().POPUP_EXIT_TITLE,
                               Localization.getMessages().POPUP_EXIT_TEXT,
                               action);
    }


    /**
     * change the flag on the fly and start a thread to save the message
     * on rms.
     */
    private static void changeFlag(Message message, int flag) {
        Log.trace(TAG_LOG, "changeFlag");

        boolean isFlagged = message.getFlags().isSet(flag);

        // Clone the old message flags
        MessageFlags oldFlags = new MessageFlags();
        oldFlags.setFlags(message.getFlags().getFlags());
        
        message.getFlags().setFlag(flag, !isFlagged);
        
        Log.debug(TAG_LOG, "changeFlag:Starting ThreadedMessageWrite thread");
        threadedWriteMessageToFolder(message, true);

        Log.debug(TAG_LOG, "changeFlag:message: " + message + "--" + message.getKey() +
                " flag " + flag + " was " + isFlagged + " and now is " +
                message.getFlags().isSet(flag));

        if (UiUtils.isIncoming(message)) {
            Log.debug(TAG_LOG, "changeFlag:message is in inbox");
            try {
                getInboxMessageList().updateMessageFlags(message.getKey(),
                        message.getFlags(), oldFlags);
            } catch (MailException ex) {
                ex.printStackTrace();
                Log.error(TAG_LOG, "changeFlag:MailException changing " +
                        "flag for message " + message.getSubject() + " - " + ex);
            }
        } else {
            if (message.getParent() == null) {
                Log.debug(TAG_LOG, "message has no parent folder");
            } else {
                Log.debug(TAG_LOG, "message is in folder " + message.getParent().getFullName());
            }
            if(message.getParent().getRole().equals(FolderData.INBOX_ROLE)) {
                getInboxMessageList().updateMessageFlags(message.getKey(),
                        message.getFlags(), oldFlags);
            } else {
                updateMessageList(message);
            }
        }
    }

    /**
     * save a message to its parent folder and call the messageManager to add
     * the message to the queue
     */
    private static void threadedWriteMessageToFolder(final Message message,
            boolean update) {
        Log.trace(TAG_LOG, "threadedWriteMessageToFolder");

        MessageWriter mw = (MessageWriter)getMessageWriter(message, update);
        mw.run();
    }

    public static void sendMessage(Message message) {
        Log.trace(TAG_LOG, "sendMessage:Sending");
        //checks if an address has been set to 
        if (!checkValidAddresses(message)) {
            showErrorDetailedAlert(
                    Localization.getMessages().INVALID_ADDRESS_FOUND_MSG,
                    Localization.getMessages().INVALID_ADDRESS_FOUND_LONG_MSG);
            return;
        }

        UIController.showInboxScreen();

        /*
         * this is to avoid that a message edited and sent from within the
         * Drafts once sent remains in the Drafts while it is in the Outbox
         */
        if (message.getParent() != null) {
            if (FolderData.DRAFTS_ROLE.equals(message.getParent().getRole())) {
                try {
                    messageManager.deleteMessage(message);
                } catch (Exception ex) {
                    Log.error(TAG_LOG, "sendMessage: " + ex);
                    ex.printStackTrace();
                }
            }
        }
        try {
            message.setSentDate(new Date());
            message.setReceivedDate(new Date());
            message.getFlags().setFlag(MessageFlags.OPENED, true);
            Address from = message.getFrom();
            messageManager.appendMessageToFolder(message,
                    messageManager.getAccountFolderFromRole(
                    getAccountFromAddress(from),
                    FolderData.OUTBOX_ROLE));
            try {
                if (message.hasAttachments()) {
                    FormattedEmailStore fes = FormattedEmailStore.getInstance();
                    fes.addMessage(message);
                }
            } catch (Exception e) {
                Log.error(TAG_LOG, "Cannot add message to formatted store " + e.toString());
            }

        } catch (Exception ex) {
            Log.error(TAG_LOG, "Error moving message to Outbox " + ex.toString());
            ex.printStackTrace();
            showErrorAlert(Localization.getMessages().SAVE_OUTBOX_ERROR);
        } finally {
            //    destroyAddressList();
        }
        sync(isFirstSync);
    }

    private static AccountFolder getAccountFromAddress(Address address) {
        AccountFolder[] accounts = messageManager.getAccounts();
        for(int i=0; i<accounts.length; i++) {
            // If the specified address is null, then return the account which
            // has the empty email address
            if(address == null) {
                if(accounts[i].getEmailAddress().equals("")) {
                    return accounts[i];
                }
                continue;
            }
            if(StringUtil.equalsIgnoreCase(accounts[i].getEmailAddress(), address.getEmail())) {
               return accounts[i];
            } else if(address.getEmail() == null && accounts[i].getEmailAddress().equals("")) {
               return accounts[i];
            }
        }
        return null;
    }

    private static boolean checkValidAddresses(Message message) {
        Log.trace(TAG_LOG, "checkValidAddresses");
        Address[] to = message.getTo();
        Address[] cc = message.getCc();
        Address[] bcc = message.getBcc();
        Address[] replyTo = message.getReplyTo();

        for (int i = 0; i < to.length; i++) {
            if (to[i].getEmail() == null) {
                return false;
            }
        }

        for (int i = 0; i < cc.length; i++) {
            if (cc[i].getEmail() == null) {
                return false;
            }
        }

        for (int i = 0; i < bcc.length; i++) {
            if (bcc[i].getEmail() == null) {
                return false;
            }
        }

        for (int i = 0; i < replyTo.length; i++) {
            if (replyTo[i].getEmail() == null) {
                return false;
            }
        }

        return true;
    }

    /**
     * Start the sync of the messages, and optionally of the contacts
     * if the parameter syncContacts is true. The sync is done using the
     * default sync type defined for the source.
     */
    public static void sync(boolean syncContacts) {
        Log.trace(TAG_LOG, "sync:Sync process for contacts: " + syncContacts);
        sync(-1, syncContacts);
    }

    /**
     * Start the SyncClient to send/receive email and, if
     * syncContacts is true, also to update the address book.
     * NOTE: if the contact sync is disabled in the config,
     *       the contact sync is not started, regardless of the value of
     *       the parameter syncContacts.
     *
     * @param syncMode the mode of the sync, as defined in SyncML class.
     *                 If the value -1 is passed, the default
     *                 value defined for the source will be used.
     * @param syncContacts true if the SyncClient should sync contacts too.
     */
    public static void sync(int syncMode, boolean syncContacts) {
        Log.trace(TAG_LOG, "sync:Sync Mode: " + syncMode+ " - " + "Sync Contacts: " + syncContacts);
        if (!syncContacts) {
            sync(SyncClient.MESSAGES, syncMode);
        } else {

            int repositories[] = new int[2];
            int modes[] = new int[2];

            repositories[0] = SyncClient.MESSAGES;
            repositories[1] = SyncClient.CONTACTS;

            modes[0] = syncMode;
            modes[1] = syncMode;
            sync(repositories, modes);
        }

    }

    /**
     * sync a single repository with given mode
     * @param repository
     * @param mode
     */
    public static void sync(int repository, int mode) {
        Log.trace(TAG_LOG, "sync:Sync Mode: " + mode + " - " + "Sync Repository: " + repository);

        int repositories[] = {repository};
        int modes[] = {mode};
        sync(repositories, modes);


    }

    private static void sync(int[] repositories, int[] modes) {
        Log.trace(TAG_LOG, "sync:Syncing reposiories");

        //#ifdef isBlackberry
        //# if (!BlackberryUtils.isDataConnectionAvailable()) {
        //#     showErrorAlert(Localization.getMessages().PLEASE_TURN_ON_RADIO);
        //#     return;
        //# }
        //#endif

        SyncClient sc = SyncClient.getSyncClient();

        MailSyncListener ml = new MailSyncListener();
        sc.setMailListener(ml);

        ContactSyncListener cl = new ContactSyncListener();
        sc.setContactListener(cl);

        sc.sync(repositories, modes);
    }

    public static void sendLaterMessage(Message message) {
        Log.trace(TAG_LOG, "sendLaterMessage, saving");

        if (!checkValidAddresses(message)) {
            showErrorDetailedAlert(
                    Localization.getMessages().INVALID_ADDRESS_FOUND_MSG,
                    Localization.getMessages().INVALID_ADDRESS_FOUND_LONG_MSG);
            return;
        }

        try {
            removeDuplicates(message);
            message.setSentDate(new Date());
            message.setReceivedDate(new Date());
            messageManager.appendMessageToFolder(message,
                    messageManager.getAccountFolderFromRole(
                    getAccountFromAddress(message.getFrom()),
                    FolderData.OUTBOX_ROLE));
            try {
                if (message.hasAttachments()) {
                    FormattedEmailStore fes = FormattedEmailStore.getInstance();
                    fes.addMessage(message);
                }
            } catch (Exception e) {
                Log.error(TAG_LOG, "Cannot add message to formatted store " + e.toString());
            }
            Log.debug(TAG_LOG, "sendLaterMessage:Message moved to outbox: "+ message.getParent().getName());
        } catch (Exception ex) {
            Log.error(TAG_LOG, "sendLaterMessage:SendLaterMessage: " + ex.toString());
            ex.printStackTrace();
        }
//updateOutboxMessageList(message);
//updateDraftMessageList(message);
//updateInboxMessageList(null);   //XXX why this???
        showAlert(
                Localization.getMessages().COMPOSE_MESSAGE_FORM_SAVED_TO_OUTBOX,
                getInboxMessageList());

    // destroyAddressList();
    }

    public static void saveMessage(Message message) {
        Log.trace(TAG_LOG, "saveMessage:Saving");
        try {
            removeDuplicates(message);
            messageManager.appendMessageToFolder(message,
                    messageManager.getAccountFolderFromRole(
                    getAccountFromAddress(message.getFrom()),
                    FolderData.DRAFTS_ROLE));
            messageManager.updateMessageFlag(message, MessageFlags.DRAFT, true);
            //message.getFlags().setFlag(MessageFlags.DRAFT, true);
            //updateDraftMessageList(message);
            //updateInboxMessageList(null);
            showAlert(Localization.getMessages().COMPOSE_MESSAGE_FORM_SAVED_TO_DRAFT,
                      getInboxMessageList());
            //destroyAddressList();
            Log.debug(TAG_LOG, "message saved to draft");
        } catch (Exception ex) {
            Log.error(TAG_LOG, "saveMessage" + ex.toString());
            showErrorAlert(
                    Localization.getMessages().UNABLE_TO_SAVE_MESSAGE_TO_DRAFT,
                    getInboxMessageList());

        //  destroyAddressList();
        }

    }

    private static void removeDuplicates(final Message message)
            throws MailException, ConfigException {
        Log.trace(TAG_LOG, "removeDuplicates");

        /*
         * this is to avoid that a message in the Drafts once edited and
         * saved to be sent later (i.e. stored in the Outbox) remains in the
         * Drafts while it is in the Outbox
         */
        if (message.getParent() != null) {
            if (FolderData.OUTBOX_ROLE.equals(message.getParent().getRole()) ||
                    FolderData.DRAFTS_ROLE.equals(message.getParent().getRole())) {
                messageManager.deleteMessage(message);
            }
        }
    }

    public static String getMyAddress() {
        Log.trace(TAG_LOG, "getMyAddress");
        mailClientConfig = getConfig();
        return (mailClientConfig.getMailAccount(0).getEmailAddress());
    }

    /**
     * build the reply message of a given message.
     *
     */
//TODO: check the cc field, it seems not to work.
    public static void replyAll(Message message) {
        Log.trace(TAG_LOG, "replyAll");
        Message m = new Message();
        try {
            m.setCc(message.getCc());
            m.setTo(message.getReplyTo());
            Address[] to = message.getTo();
            for (int i = 0; i <
                    to.length; i++) {
                if (!StringUtil.equalsIgnoreCase(to[i].getEmail(), getMyAddress())) {
                    to[i].setType(Address.CC);
                    m.addRecipient(to[i]);
                }

            }
            m.setSubject(RE + message.getSubject());
            //setRepliedFlag(message);
            setDelayedFlag(message, MessageFlags.ANSWERED);
            updateComposeMessageScreen(m, getReplyText(message));
            // getContactList().emptySearchString();
            showComposeMessageScreen(display.getCurrent(), getComposeMessageScreen().getBody());
        } catch (MailException ex) {
            Log.error(TAG_LOG, "replyAll:Error in reply all message function: " + ex.getMessage());
            ex.printStackTrace();
        }

    }

    /**
     * Called from ViwMessage class to edit the current message into the sent 
     * folder
     * @param m the message to be edited
     */
    public static void editAsNew(Message message) {
        //Use another reference as the one on the view message class
        //could be flushed out
        Message m = new Message();
        m = message;
        m.setMessageId(m.createUniqueMessageIDValue());
        updateComposeMessageScreen(m, "");
        showComposeMessageScreen(UIController.display.getCurrent(),
                UIController.getComposeMessageScreen().getBody());        
    }
    
    /**
     * Get the complete message (up to the maxObjSize).
     * This method relied on SyncClient.syncSingleMessage which is non blocking,
     * therefore this method is non blocking as well. The message can be got
     * by using a SingleMessageListener.
     */
    public static void getFullMessage(Message message) {
        Log.trace(TAG_LOG, "getFullMessage");
        try {
            String folder = message.getParent().getName();
            String luid = message.getKey();
            MailSyncSingleMessageListener lis =
                    new MailSyncSingleMessageListener(viewMessageScreen);
            SyncClient.getSyncClient().setSingleMessageListener(lis);
            SyncClient.getSyncClient().syncSingleMessage(folder, luid, false);
        } catch (ConfigException e) {
            Log.error(TAG_LOG, "getFullMessage:Exception occurred: " + e.toString());
            e.printStackTrace();
        } catch (MailException e) {
            Log.error(TAG_LOG, "getFullMessage:Exception occurred: " + e.toString());
            e.printStackTrace();
        }

    }

    private static String getReplyText(Message message) {
        Log.trace(TAG_LOG, "getReplyText");
        StringBuffer sb = new StringBuffer();
        sb.append("\n\n");

        //added a delimiter
        sb.append("----\n");

        try {
            //TODO: use right timiezone offset here
            Date dateObj = message.getSentDate();
            Calendar calendar = Calendar.getInstance();
            calendar.setTime(dateObj);
            calendar.setTimeZone(TimeZone.getDefault());

            // this is only for visualization purposes
            //TODO: check if the variables in formatLocalTime are really used
            String dateTime =
                    MailDateFormatter.getReplyDateString(
                    MailDateFormatter.formatLocalTime(calendar.getTime()));


            String date = dateTime.substring(0, dateTime.lastIndexOf(' '));
            String time = dateTime.substring(dateTime.lastIndexOf(' '));

            sb.append(Localization.getMessages().STRING_ON).
                    append(" ").append(date).append(" ").append(Localization.getMessages().STRING_AT).append(time).append("m, ").
                    append((message.getFrom() == null) ? "" : message.getFrom().getVisibleName()).
                    append(" ").append(Localization.getMessages().REPLY_WROTE).
                    append("\n").append(message.getTextContent());

        } catch (MailException ex) {
            Log.error(TAG_LOG, "getReplyText:Exception occurred: " + ex);
            ex.printStackTrace();
        }

        return sb.toString();

    }

    public static Address getMyFrom() {
        Log.trace(TAG_LOG, "getMyFrom");
        try {
            String address = getConfig().getMailAccount(0).getEmailAddress();
            String name = getConfig().getMailAccount(0).getVisibleName();
            if (StringUtil.isNullOrEmpty(address)) {
                return null;
            } else {
                return new Address(Address.FROM, name, address);
            }
        } catch (MailException ex) {
            ex.printStackTrace();
            UIController.showAccountSettings(display.getCurrent());
            UIController.showErrorAlert(
                    Localization.getMessages().UNABLE_TO_FIND_PERSONAL_ADDRESS);
            Log.error(TAG_LOG, "getMyFrom:MailException: returning null");
            return null;
        }
    }

    /**
     * Returns the current MailClientConfig, or the default one
     * in case of errors.
     */
    public static MailClientConfig getConfig() {
        Log.trace(TAG_LOG, "getConfig");
        try {
            return ConfigManager.getConfig();
        } catch (ConfigException e) {
            // TODO shall we alert the user?
            Log.error(TAG_LOG, "getConfig:Error retrieving configuration: " + e.getMessage());
            MailClientConfig mcc = new MailClientConfig();
            try {
                ConfigManager.saveConfig(mcc);
            } catch (Exception ex) {
                Log.error(TAG_LOG, "getConfig:Can't save default config!!! " + ex.toString());
            }
            return mailClientConfig;
        }
    }

    /**
     * Save the current configuration to the persistent storage.
     */
    public static void saveConfig() {
        Log.trace(TAG_LOG, "saveConfig:Saving configuration");
        try {
            ConfigManager.saveConfig();
        } catch (Exception e) {
            // TODO: shall we alert the user?
            Log.error(TAG_LOG, "Error saving configuration: " + e.getMessage());
        }

    }

    /**
     * Save new configuration to persistent memory.
     * If username field is changed a new account is initialized and
     * slow sync are performed both for contact list and Emails
     * @param mailClientConfig is the new configuration to be saved
     */
    public static void saveNewConfig(MailClientConfig mailClientConfig) {
        Log.trace(TAG_LOG, "saveNewConfig Saving configuration");
        try {
            MailClientConfig oldConfig = ConfigManager.getConfig();
            UserAccount oldAccount = oldConfig.getUserAccount();
            UserAccount newAccount = mailClientConfig.getUserAccount();
            String oldUrl = oldAccount.getUrl();
            String newUrl = newAccount.getUrl();
            String oldUser = oldAccount.getUser();
            String newUser = newAccount.getUser();
            String oldPassword = oldAccount.getPassword();
            String newPassword = newAccount.getPassword();

            String server = null;
            boolean isAccountChanged = false;
            if ((oldUrl != null && !oldUrl.equals(newUrl)) ||
                    (oldUser != null && !oldUser.equals(newUser)) ||
                    (oldPassword != null && !oldPassword.equals(newPassword))) {

                server = StringUtil.extractAddressFromUrl(newUrl, 
                        StringUtil.getProtocolFromUrl(newUrl));
                Log.debug(TAG_LOG, "saveNewConfig New Server Found:" + server);
                UpdaterManager.getInstance().setUrl(server);
                Log.debug(TAG_LOG, "saveNewConfig:UpdaterManager Server updated");

                Log.info(TAG_LOG, "saveNewConfig CTP Server must be restarted");
                isAccountChanged = true;
            }

            ConfigManager.saveConfig(mailClientConfig);

            //Restart the CTP Service if a new account has been found
            if (isAccountChanged) {
                CTPManager.getInstance().restartCTP(mailClientConfig);
            }

        } catch (Exception e) {
            Log.error(TAG_LOG, "saveNewConfig:Unable to save new configuration: " + e.getMessage());
            e.printStackTrace();
        }

    }

    /**
     * Loads the source config from the store, if present.
     *
     * @param name the name of the source to load.
     * @return the config, or null in case of error.
     */
    public static SourceConfig getSourceConfig(
            String name) {
        Log.trace(TAG_LOG, "getSourceConfig");
        SourceConfig ret = new SourceConfig();
        try {
            ConfigManager.load("source." + name, ret);
            return ret;

        } catch (Exception e) {
            Log.error(TAG_LOG, "getSourceConfig:Exception occurred: " + e.toString());
            return null;
        }

    }

    /**
     * Save the given source config.
     *
     * @param sc the SourceConfig to save.
     *
     * @throws ConfigException if the config is not present
     * @throws IOException if an error occurred during the deserialization
     */
    public static void saveSourceConfig(SourceConfig sc) {
        Log.trace(TAG_LOG, "saveSourceConfig:Saving configuration");
        try {
            // The source config is stored in a record named "source.<sourcename>"
            ConfigManager.save("source." + sc.getName(), sc);
            Log.info(TAG_LOG, "saveSourceConfig" + sc.getName() + " saved.");

        } catch (Exception e) {
            Log.error(TAG_LOG, "saveSourceConfig Exception occurred: " + e.toString());
        // TODO: shall we put an alert here?
        }

    }

    /** Enable or disable contact synchronization. */
    public static void enableContactSync(boolean enable) {
        Log.trace(TAG_LOG, "enableContactSync Enabling");
        SourceConfig sc = getSourceConfig(SourceConfig.CONTACT);
        if (sc != null) {
            if (enable) {
                sc.setSyncMode(SyncML.ALERT_CODE_FAST);
            } else {
                sc.setSyncMode(SyncML.ALERT_CODE_NONE);
            }

            saveSourceConfig(sc);
        }

    }

    public static void deleteMessage(Message msg) {
        Log.trace(TAG_LOG, "deleteMessage");
        try {
            getMessageList(msg).deleteMessage(msg.getKey());
            messageManager.deleteMessage(msg);
        } catch (Exception ex) {
            ex.printStackTrace();
            Log.error(TAG_LOG, "deleteMessage:Error deleting" +
                    " message " + msg.getSubject() + " - " + ex);
            showErrorAlert(
                    Localization.getMessages().
                    getGENERIC_UNABLE_TO_DELETE_MESSAGE(msg.getSubject()));
        }
    }

    public static void deleteMessageWithConfirmation(Message msg) {
        if (UIController.getConfig().getDeleteConfirmation()) {

            showConfirmationDialog(Localization.getMessages().POPUP_DELETE_MESSAGE_TITLE,
                                   Localization.getMessages().POPUP_DELETE_MESSAGE_TEXT,
                                   new DeletePopupAction(msg));
        } else {
            UIController.deleteMessage(msg);
        }
    }

    public static void saveNewAccountWithConfirmation(MailClientConfig newConfig) {
        Log.info(TAG_LOG, "Saving new account. Account has changed");
        SavingAccountAction action = new SavingAccountAction(newConfig);
        showConfirmationDialog(Localization.getMessages().SAVING_ACCOUNT_POPUP_TITLE,
                               Localization.getMessages().SAVING_ACCOUNT_POPUP_MSG,
                               action);
    }

    public static void resetInboxWithConfirmation() {
        ResetPopupAction action = new ResetPopupAction();
        showConfirmationDialog(Localization.getMessages().SLOW_SYNC_POPUP_TITLE,
                               Localization.getMessages().RESETINBOX_MESSAGE,
                               action);
    }

    public static void deleteAllWithConfirmation(String role) {
        DeleteAllPopupAction action = new DeleteAllPopupAction(role);
        showConfirmationDialog(Localization.getMessages().POPUP_DELETE_ALL_TITLE,
                               Localization.getMessages().POPUP_DELETE_ALL_TEXT,
                               action);
    }

    public static void askAPNPermissionByModalDialog(String config) {

        SaveConfigPopupAction popupAction = new SaveConfigPopupAction();

        String title = Localization.getMessages().CAN_USE_CONNECTION_TITLE;
        String text = Localization.getMessages().CAN_USE_CONNECTION1 + " "
                      + config + " " + Localization.getMessages().CAN_USE_CONNECTION2;

        showConfirmationDialog(title, text, popupAction,
                               Localization.getMessages().POPUP_ACCEPT,
                               Localization.getMessages().POPUP_DENY);
    }

    public static String getVersion() {
        Log.trace(TAG_LOG, "getVersion");
        return ConfigManager.getClientVersion();
    }

    public static String getClientName() {
        Log.trace(TAG_LOG, "getClientName");
        return ConfigManager.getClientName() + " " + 
                Customization.getInstance().getAboutNameSuffix();
    }

    public static String getClientVendor() {
        Log.trace(TAG_LOG, "getClientVendor");
        return ConfigManager.getClientVendor();
    }

    public static void emptyFolder(String path) {
        Log.trace(TAG_LOG, "emptyFolder: " + path);
        try {
            messageManager.emptyFolder(messageManager.getFolder(path, true));
        } catch (MailException ex) {
            ex.printStackTrace();
            Log.error(TAG_LOG, "Unable to recreate folder " + path);
        }
    }

    public static void emptyFoldersFromRole(String role) {
        Log.trace(TAG_LOG, "emptyFoldersFromRole");
        try {
            Folder[] folders = messageManager.getFoldersFromRole(role);
            if(folders == null) {return;}
            for(int i=0; i<folders.length; i++) {
                messageManager.emptyFolder(folders[i]);
            }
        } catch (MailException ex) {
            ex.printStackTrace();
        }
        // Update folder counters
    }

    public static void showAdvancedContactScreen(Contact contact) {
        Log.trace(TAG_LOG, "showAdvancedContactScreen");
        backStack.push(display.getCurrent());
        UIController.display.setCurrent(new AdvancedContactForm(contact));
    }

    /**
     * delete a contact
     **/
    public static void deleteContact(Contact contact) {
        Log.trace(TAG_LOG, "deleteContact");
        try {
            UIController.contactManager.removeContact(contact.getContactId());
        } catch (ContactManagerException ex) {
            UIController.showErrorAlert(
                    Localization.getMessages().UNABLE_TO_DELETE_CONTACT);
        }
    }

    public static void deleteContactWithConfirmation(Contact contact) {

        DeleteContactPopupAction action = new DeleteContactPopupAction(contact);
        StringBuffer message = new StringBuffer();
       
        // We show the message and the visible name of the contact being deleted
        message.append(Localization.getMessages().POPUP_DELETE_CONTACT_TEXT);
        message.append(" ");
        String name = contact.getVisibleName();
        if (name == null) {
            message.append(Localization.getMessages().POPUP_DELETE_UNNAMED_CONTACT);
        } else {
            message.append(name);
        }
        message.append("?");

        showConfirmationDialog(Localization.getMessages().POPUP_DELETE_CONTACT_TITLE,
                               message.toString(),
                               action);
    }


    public static void synchContacts() throws SyncException {
        Log.trace(TAG_LOG, "synchContacts");
        if (contactManager.getContactCount() >= contactManager.getDefaultContactNumber()) {
            Log.info(TAG_LOG, "synchContacts]Addressbook is full. Remove some contact from server and try again.");
            showAlert(Localization.getMessages().AB_LIMIT_ERROR_MSG);
            getContactList().setTitle(getContactList().getDefaultTitle());
            return;
        }

        SourceConfig sc = getSourceConfig(SourceConfig.CONTACT);
        // Check if the contact sync is not enabled.
        if (sc != null && sc.getSyncMode() == SyncML.ALERT_CODE_NONE) {
            Log.info(TAG_LOG, "synchContacts:Contact sync disabled.");
        } else {
            //SyncClient.getSyncClient().sync(SyncClient.CONTACTS);
            SyncClient syncClient = SyncClient.getSyncClient();
            ContactSyncListener cl = new ContactSyncListener();
            syncClient.setContactListener(cl);
            sync(SyncClient.CONTACTS, -1);
        }

    }

    private static String getForwardText(Message message) {
        Log.trace(TAG_LOG, "getForwardText");
        return getReplyText(message);
    }

    public static void createContactManager() {
        Log.trace(TAG_LOG, "createContactManager");
        try {
            Log.info(TAG_LOG, "createContactManager:Creating Contact Store.");
            contactManager =
                    ContactManagerFactory.getContactManager(
                    ContactManager.RMS_TYPE);
        } catch (RecordStoreException ex) {
            Log.error(TAG_LOG, "createContactManager:Exception Occurred: " + ex);
            ex.printStackTrace();
        }

    }

    public static void resetInboxTitle() {
        Log.trace(TAG_LOG, "resetInboxTitle");
        getInboxMessageList().resetTitle();
    }

    /**
     * resort inbox messageinfo list
     */
    public static void resortInboxMessages() {
        Log.trace(TAG_LOG, "resetInboxMessages");
        getInboxMessageList().setMessageList(
                bubbleSortPerDate(getInboxMessageList().getMessageList()));
    }

    /**
     * reload the inbox messages from rms and reset the inbox title to the default title
     */
    public static void resetInboxMessageList() {
        Log.trace(TAG_LOG, "resetInboxMessageList");

        inboxMessageList = getInboxMessageList();
        inboxMessageList.resetTitle();
        reloadInboxMessageListMessages();
    }

    /**
     * reload the inbox message list messages
     *
     */
    public static void reloadInboxMessageListMessages() {
        Log.trace(TAG_LOG, "reloadInboxMessageListMessages");
        AccountFolder currentAccount = getCurrentMailAccount();
        if(currentAccount == null) {
            // There is no account in the store
            getInboxMessageList().setMessageList(new Vector());
            return;
        }
        getInboxMessageList().setMessageList(getSortedMessages(
                messageManager.getAccountFolderFromRole(currentAccount,
                FolderData.INBOX_ROLE)));
    }

    public static void cancelComposeWithConfirmation(Message message) {
        PopupCancelCompose action = new PopupCancelCompose(message);
        showConfirmationDialog(Localization.getMessages().CMF_CANCEL_TITLE,
                               Localization.getMessages().CMF_CANCEL_COMMAND,
                               action);
    }


    public static void openAttachmentWithConfirmation(BodyPart bp) {
        String url = bp.getAttachUrl();
        //#ifdef isBlackberry
        //# UIController.openUrl(url);
        //#else
            StringBuffer msg = new StringBuffer();
            msg.append(Localization.getMessages().OPEN_ATTACHMENT_1)
               .append(" ").append(bp.getFileName()).append(" ")
               .append(Localization.getMessages().OPEN_ATTACHMENT_2);

            showConfirmationDialog(Localization.getMessages().OPEN_BROWSER_MESSAGE_TITLE,
                                   msg.toString(),
                                   new BrowserOpenPopupAction(url));
        //#endif
    }

    public static void resetContactsWithConfirmation() {

        showConfirmationDialog(Localization.getMessages().RESETCONTACTS_TITLE,
                               Localization.getMessages().RESETCONTACTS_MESSAGE,
                               new ResetContactsPopupAction());
    }


    /**
     * @return the contactmanager
     */
    public static ContactManager getContactManager() {
        Log.trace(TAG_LOG, "getContactManager");
        if (null == contactManager) {
            createContactManager();
        }

        return contactManager;
    }

    /**
     * shows the given displayable
     * @param toShow the displayable to show
     * @param backscreen the displayable to push in the stack.
     */
    public static void showDisplayable(Displayable toShow, Displayable backscreen) {
        Log.trace(TAG_LOG, "showDisplayable");
        backStack.push(backscreen);
        display.setCurrent(toShow);
    }

    public static ContactList getContactList() {
        Log.trace(TAG_LOG, "getContactList");

        if (contactList == null) {
            contactList = new ContactList();
        }

        return contactList;
    }

    private static Runnable getPlatformRequestHandler(String request) {
        Log.trace(TAG_LOG, "getPlatformRequestHandler");
        if (prh == null) {
            prh = new PlatformRequestHandler(midlet);
        }

        prh.setRequest(request);

        return prh;

    }

    private static Runnable getMessageWriter(Message message, boolean update) {
        Log.trace(TAG_LOG, "getMessageWriter");

        if (messageWriter == null) {
            messageWriter = new MessageWriter();
        }

        messageWriter.setMessage(message);
        messageWriter.setUpdate(update);

        return messageWriter;

    }

    public static void threadedPlatformRequest(String request) {
        Log.trace(TAG_LOG, "threadedPlatformRequest");
        UIController.threadPool.startThread(getPlatformRequestHandler(request));
    }

    public static boolean checkContactListFull() {
        Log.trace(TAG_LOG, "checkContactListFull");
        return (getContactManager().getContactCount() >=
                getContactManager().getDefaultContactNumber() && getContactManager().getDefaultContactNumber() != -1);
    }

    /**
     * return the message related message list
     * @param message is the reference message
     */
    public static MessageList getMessageList(
            Message message) {
        Log.trace(TAG_LOG, "getMessageList");
        String folderName = message.getParent().getRole();
        if (folderName.equals(FolderData.INBOX_ROLE)) {
            return getInboxMessageList();
        } else if (folderName.equals(FolderData.OUTBOX_ROLE)) {
            return getOutboxMessageList();
        } else if (folderName.equals(FolderData.DRAFTS_ROLE)) {
            return getDraftMessageList();
        } else if (folderName.equals(FolderData.SENT_ROLE)) {
            return getSentMessageList();
        }
        return null;
    }

    public static Drawer getDrawer() {
        return DrawerFactory.getDrawer();
    }

    private static void doPlatformRequest(String request) throws Exception {
        Log.trace(TAG_LOG, "doPlatformRequest:Request: " + request);
//#ifdef Exit
//#         PlatformRequestPopupAction action = new PlatformRequestPopupAction(request);
//#         showConfirmationDialog(Localization.getMessages().POPUP_EXIT_TITLE,
//#                                ConfigManager.getClientName() + " " +
//#                                Localization.getMessages().POPUP_PLATFORM_REQUEST_EXIT + " " +
//#                                ConfigManager.getClientName() + " ?",
//#                                action);
//#endif

//#ifdef Threaded
//#         threadedPlatformRequest(request);
//#elifndef Exit
        midlet.platformRequest(request);
//#endif
    //exit form Exit block
    }

    /**
     * call a phonenumber.
     *
     * @param contact the contact to be call
     */
    public static void phoneCall(Contact contact, Displayable backScreen) {
        Log.trace(TAG_LOG, "phoneCall:Starting phone call");

        try {
            if (StringUtil.isNullOrEmpty(contact.getHomePhone()) && StringUtil.isNullOrEmpty(contact.getJobPhone())) {
                doPlatformRequest("tel:" + checkPhoneNumberFormat(contact.getMobilePhone()));
            } else if (StringUtil.isNullOrEmpty(contact.getHomePhone()) && StringUtil.isNullOrEmpty(contact.getMobilePhone())) {
                doPlatformRequest("tel:" + checkPhoneNumberFormat(contact.getJobPhone()));
            } else if (StringUtil.isNullOrEmpty(contact.getJobPhone()) && StringUtil.isNullOrEmpty(contact.getMobilePhone())) {
                doPlatformRequest("tel:" + checkPhoneNumberFormat(contact.getHomePhone()));
            } else {
                backStack.push(backScreen);
                display.setCurrent(new ContactPhoneNumbersList(contact));
            }

        } catch (ConnectionNotFoundException ex) {
            ex.printStackTrace();
            Log.error(TAG_LOG, "phoneCall:Exception occurred: " + ex);
            showErrorAlert(Localization.getMessages().ERROR_CALLING_NUMBER);
        } catch (Exception e) {
            e.printStackTrace();
            Log.error(TAG_LOG, "phoneCall:Exception occurred: " + e);
        }
    }

    private static String checkPhoneNumberFormat(String phoneNumber) {
        Log.trace(TAG_LOG, "checkPhoneNumberFormat");
        StringBuffer num = new StringBuffer();

        for (int i = 0; i <
                phoneNumber.length(); i++) {
            char charToCheck = phoneNumber.charAt(i);
            if (charToCheck == '(') {
                //Do nothing
            } else if (charToCheck == ')') {
                //Do nothing
            } else if (charToCheck == ' ') {
                //Do nothing
            } else if (charToCheck == '-') {
                //Do nothing
            } else {
                num.append(charToCheck);
            }

        }

        phoneNumber = num.toString();
        num =
                null;

        return phoneNumber;
    }

    /**
     * reset the titles after a sync.
     * currently used only to reset the title of the viewmessage screen if
     * get full operation is not completed correctly or reset the inbox when errors
     * during sync occurred
     * 
     */
    static void resetTitles() {
        Log.trace(TAG_LOG, "resetTitles");
        getInboxMessageList().resetTitle();
    }

    /**
     * return true if the given key is a clear key.
     */
    public static boolean isClearKey(int keyCode) {
        Log.trace(TAG_LOG, "isClearKey: " + keyCode);

        return (keyCode == '0' || 
                keyCode == -8 || // cancel key code
                keyCode == 8     // backspace code
                );

    }

    /**
     * orrible -and temporary- hack to fix  multi-handlekey calls on bb
     **/
    private static boolean minTimeElapsed() {
        Log.trace(TAG_LOG, "minTimeElapsed");

        boolean ret = true;
        //#ifdef isBlackberry
        //# long now = System.currentTimeMillis();
        //# ret = (now > lastTimeStarKeypressed + 500) ;
        //# if (!ret){
        //# Log.debug(TAG_LOG, "dropping keypressed");
        //# }
        //# lastTimeStarKeypressed = now;
        //#endif

        return ret;
    }

    public static void loadContacts() {
        Log.trace(TAG_LOG, "loadContacts");
        contactsLoader = new ContactsLoader();
        contactsLoader.lock();

        Thread t = UIController.getThreadPool().startThread(contactsLoader);
        t.setPriority(Thread.MIN_PRIORITY);
    }

    public static ContactsLoader getContactsLoader() {
        Log.trace(TAG_LOG, "getContactsLoader");
        return contactsLoader;
    }

    public static void checkTimerAlarmAfterSync() {
        Log.trace(TAG_LOG, "checkTimerAlarmAfterSync");
        if (syncCaller == USER) {
        } else if (syncCaller == SAN_MESSAGE) {
            //Cancel the timer task if the sync ends succesfully
            AlarmManager.getInstance().cancelTimerTask();
        } else if (syncCaller == SCHEDULER) {
        } else if (syncCaller == CONNECTION_ERROR_TIMER) {
        }
    }

    public static int getSyncCaller() {
        Log.trace(TAG_LOG, "getSyncCaller");
        return syncCaller;
    }

    public static void setSyncCaller(int syncCaller) {
        Log.trace(TAG_LOG, "setSyncCaller");
        switch (syncCaller) {
            case USER:
                Log.info(TAG_LOG, "SyncCaller set to USER");
                alarmCounter =
                        0;
                break;
            case SCHEDULER:
                Log.info(TAG_LOG, "SyncCaller set to SCHEDULER");
                if (syncCaller != SCHEDULER) {
                    alarmCounter = 0;
                }

                break;
            case SAN_MESSAGE:
                Log.info(TAG_LOG, "SyncCaller set to SAN_MESSAGE");
                if (syncCaller != SAN_MESSAGE) {
                    alarmCounter = 0;
                }

                break;
            default:
                break;
        }

        UIController.syncCaller = syncCaller;
    }

    public static void handleSmartSlowSyncUnsupported() {
        Log.trace(TAG_LOG, "handleSmartSlowSyncUnsupported");
        String msg = Localization.getMessages().SMART_SLOW_SYNC_UNSUPPORTED;
        UIController.enableSyncCommandsKeepingSettings(false);
        UIController.showErrorAlert(msg);
        UIController.resetTitles();
        CTPManager.getInstance().setOfflineMode(true);
    }

    public static void showFileBrowseScreen (Displayable d, Message msg){
        backStack.push(d);
        FileExplorerScreen fes = getFileBrowserScreen(d,msg);
        display.setCurrent(fes);
    }

    private static FileExplorerScreen getFileBrowserScreen(Displayable d,Message msg) {
        if(fileExplorerScreen == null){
            fileExplorerScreen = new FileExplorerScreen(d);
        } else {
            fileExplorerScreen.setDisplayable(d);
        }
        AttachFileListener afl = new AttachFileListener(d, msg);
        fileExplorerScreen.setListener(afl);
        return fileExplorerScreen;
    }

    public static void showImageViewerScreen(Displayable d, String path, String name,FileExplorerScreenListener listener) {
        ImageViewerScreen preview = new ImageViewerScreen(path, name,listener);
        try {
            backStack.push(d);
            display.setCurrent(preview);
        } catch (Exception e) {
            Log.error(TAG_LOG, "Cannot show preview for " + name + " because " + e.toString());
        }
    }
}

/**
 * private class to handle platform request
 */
class PlatformRequestHandler implements Runnable {

    private static final String TAG_LOG = "UIController.PlatformRequestHandler";

    private String request;
    private MIDlet midlet;

    public PlatformRequestHandler(Funambol midlet) {
        this.midlet = midlet;
    }

    public void setRequest(String request) {
        this.request = request;
    }

    public void run() {
        try {
            Log.trace(TAG_LOG, "Starting thread");
            midlet.platformRequest(request);
        } catch (ConnectionNotFoundException cnfe) {
            cnfe.printStackTrace();
            Log.error(TAG_LOG, "Cannot complete platform request: " + cnfe.getMessage());
        }

    }
}

/**
 * private class for writing message to folder
 */
class MessageWriter implements Runnable {

    private static final String TAG_LOG = "UIController.MessageWriter";

    private Message message = null;
    private boolean update = false;

    public MessageWriter() {
    }

    public void setMessage(Message m) {
        message = m;
    }

    public void setUpdate(boolean update) {
        this.update = update;
    }

    public void run() {
        if (message != null) {
            // This method simply updated the FlagQueue
            Log.debug(TAG_LOG, "Calling MessageManager to update the flag queue");
            UIController.messageManager.updateMessageFlags(message,
                    message.getFlags());
            Log.trace(TAG_LOG, "MessageManager updated the flag queue");
            try {
                if (update) {
                    Log.debug(TAG_LOG, "about to update message");
                    UIController.messageManager.updateMessage(message);
                    Log.trace(TAG_LOG, "message updated");
                } else {
                    UIController.messageManager.appendMessageToFolder(
                            message, message.getParent());
                }
            } catch (MailException ex) {
                Log.error(TAG_LOG, "threadedWriteMessageToFolder: " + ex.toString());
                ex.printStackTrace();
            } finally {
                message = null;
            }
        }
    }
}
