/*
 * Funambol is a mobile platform developed by Funambol, Inc. 
 * Copyright (C) 2009 Funambol, Inc.
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission 
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE 
 * WARRANTY OF NON INFRINGEMENT  OF THIRD PARTY RIGHTS.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Affero General Public License 
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 * 
 * You can contact Funambol, Inc. headquarters at 643 Bair Island Road, Suite 
 * 305, Redwood City, CA 94063, USA, or at email address info@funambol.com.
 * 
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 * 
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably 
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol".
 */
package com.funambol.mailclient.ui.view;

import javax.microedition.lcdui.TextField;
import javax.microedition.lcdui.TextBox;
import javax.microedition.lcdui.ChoiceGroup;
import java.util.Vector;

public class BasicTestableInputField implements TestableInputField {

    private String      value;
    private String      label;
    private TextField   textField;
    private TextBox     textBox;
    private ChoiceGroup choiceGroup;

    public BasicTestableInputField(String value) {
        this.value = value;
    }

    public BasicTestableInputField(TextField textField) {
        this.textField = textField;
    }

    public BasicTestableInputField(TextBox textBox) {
        this.textBox = textBox;
    }

    public BasicTestableInputField(ChoiceGroup choiceGroup) {
        this.choiceGroup = choiceGroup;
    }

    public String getText() {
        if (textField != null) {
            return textField.getString();
        } else if (textBox != null) {
            return textBox.getString();
        } else if (choiceGroup != null) {
            return "" + choiceGroup.getSelectedIndex();
        } else {
            return value;
        }
    }

    public void setText(String value) {
        if (textField != null) {
            textField.setString(value);
        } else if (textBox != null) {
            textBox.setString(value);
        } else if (choiceGroup != null) {
            int val = Integer.parseInt(value);
            choiceGroup.setSelectedIndex(val, true);
        } else {
            this.value = value;
        }
    }

    public String getLabel() {
        if (textField != null) {
            return textField.getLabel();
        } else if (textBox != null) {
            return textBox.getTitle();
        } else if (choiceGroup != null) {
            return choiceGroup.getLabel();
        } else {
            return label;
        }
    }
}

 
