/*
 * Funambol is a mobile platform developed by Funambol, Inc.
 * Copyright (C) 2003 - 2007 Funambol, Inc.
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE
 * WARRANTY OF NON INFRINGEMENT  OF THIRD PARTY RIGHTS.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 *
 * You can contact Funambol, Inc. headquarters at 643 Bair Island Road, Suite
 * 305, Redwood City, CA 94063, USA, or at email address info@funambol.com.
 *
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 *
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol".
 */

package com.funambol.mailclient;

/**
 * Allows to customize application properties
 */
public class Customization {

    // Account settings customization
    private final String  SERVER_URL         = "http://my.funambol.com/sync";
    private final String  USERNAME           = "";
    private final String  PASSWORD           = "";

    // About customization
    private final String  ABOUT_COPYRIGHT    = "Copyright (C) 2010 Funambol, Inc.";
    private final String  ABOUT_SITE         = "www.funambol.com";
    private final String  ABOUT_NAME_SUFFIX  = "JavaME Email Client";
    private final boolean SHOW_ABOUT_LICENCE = true;
    private final boolean SHOW_POWERED_BY    = false;

    // Help customization
    private final boolean HELP_ENABLED       = true;

    // Alerts customiation
    private final String ALERT_TITLE        = "Funambol";

    //// ------------------- END OF CUSTOMIZABLE FIELDS --------------------////
    

    private static Customization instance = null;

    private Customization() { }

    public static Customization getInstance() {
        if (instance == null) {
            instance = new Customization();
        }
        return instance;
    }

    public String getServerUrl() {
        return SERVER_URL;
    }

    public String getUsername() {
        return USERNAME;
    }

    public String getPassword() {
        return PASSWORD;
    }

    public String getAboutCopyright() {
        return ABOUT_COPYRIGHT;
    }

    public String getAboutSite() {
        return ABOUT_SITE;
    }

    public String getAboutNameSuffix() {
        return ABOUT_NAME_SUFFIX;
    }

    public boolean showAboutLicence() {
        return SHOW_ABOUT_LICENCE;
    }

    public boolean showPoweredBy() {
        return SHOW_POWERED_BY;
    }

    public boolean helpEnabled() {
        return HELP_ENABLED;
    }

    public String getAlertTitle() {
        return ALERT_TITLE;
    }
}


